Rem This is a simple file menu editor PD 2022.

' declare all default variables
DefDbl A-Z
Rem $DYNAMIC

' boolean constants
Const Dfalse = 0#
Const Dtrue = -1#
Const False = 0
Const True = -1
Const SFalse = 0!
Const STrue = -1!

Rem color constants
' low intensity/background
Const Black = 0
Const BBlue = 1
Const BGreen = 2
Const BCyan = 3
Const BRed = 4
Const BMagenta = 5
Const BYellow = 6
Const Plain = 7

' high intensity foreground
Const Gray = 8
Const Blue = 9
Const Green = 10
Const Cyan = 11
Const Red = 12
Const Magenta = 13
Const Yellow = 14
Const White = 15

' break constants
Const BreakColor = 12 ' red
Const BreakMessage = "*break*"
Const BreakColor2 = 12 ' red
Const BreakMessage2 = "*line break*"
Const BreakColor3 = 12 ' red
Const BreakMessage3 = "*variable break*"
Const AutoSaveAlertColor = 12 ' red
Const AutosaveAlertMessage = "*alert*"
Const MoreBreakColor = 12 ' red
Const MoreBreakMessage = "*break*"

' scrnedit search color
Const Scolor = Red ' foreground
Const Scolor2 = BBlue ' background

' dot display counter
Const DotCount = 5
Const DotChar = "."

' maximum integer constant
Const MaxInt = 32766 ' zero-based
Const MaxLong = 2147483647

' declare library constants.
Const MAX_PATH = 260
Const INVALID_HANDLE_VALUE = -1
Const ERROR_FILE_NOT_FOUND = 2
Const ERROR_NO_MORE_FILES = &H12
Const FILE_FLAG_BACKUP_SEMANTICS = &H02000000 ' CreateFile directory flag
Const ByteDivisor = 1024
Const ByteDivisor2 = 1024

' declare library structures.
Type FILETIME
   dwLowDateTime As _Unsigned Long
   dwHighDateTime As _Unsigned Long
End Type

Type SYSTEMTIME
   wYear As Integer
   wMonth As Integer
   wDayOfWeek As Integer
   wDay As Integer
   wHour As Integer
   wMinute As Integer
   wSecond As Integer
   wMilliseconds As Integer
End Type

Type WIN32_FIND_DATAA
   dwFileAttributes As _Unsigned Long
   ftCreationTime As FILETIME
   ftLastAccessTime As FILETIME
   ftLastWriteTime As FILETIME
   nFileSizeHigh As _Unsigned Long
   nFileSizeLow As _Unsigned Long
   dwReserved0 As _Unsigned Long
   dwReserved1 As _Unsigned Long
   cFileName As String * Max_path
   cAlternateFileName As String * 14
End Type

' declare external library
Declare Library "mem"
   Function MemInUsePercent~&&
   Function TotalPhysicalMem~&&
   Function FreePhysicalMem~&&
   Function TotalPagingFile~&&
   Function FreePagingFile~&&
   Function TotalVirtualMem~&&
   Function FreeVirtualMem~&&
   Function FreeExtendedMem~&&
   Function GetCPULoad#
End Declare

' declare external libraries.
Declare Dynamic Library "kernel32"
   Function FindFirstFileA~%& (ByVal lpFileName~%&, Byval lpFindFileData~%&)
   Function FindNextFileA& (ByVal hFindFile~%&, Byval lpFindFileData~%&)
   Function FindFirstFileW~%& (ByVal lpFileName~%&, Byval lpFindFileData~%&)
   Function FindNextFileW& (ByVal hFindFile~%&, Byval lpFindFileData~%&)
   Function FindClose& (ByVal hFindFile~%&)

   Function GetVolumeInformationA& (lpRootPathName$, lpVolumeNameBuffer$, Byval nVolumeNameSize~&, lpVolumeSerialNumber~&, lpMaximumComponentLength~&, lpFileSystemFlags~&, lpFileSystemNameBuffer$, Byval nFileSystemNameSize&)
   Function GetDiskFreeSpaceA& (f$, sectors&, bytes&, free&, total&)
   Function GetDiskFreeSpaceExA& (filename$, free As _Unsigned _Integer64, total As _Unsigned _Integer64, free2 As _Unsigned _Integer64)
   Function SetVolumeLabelA% (d$, f$)

   Function GetFileTime& (ByVal hFile As _Offset, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME)
   Function SetFileTime& (ByVal hFile As _Offset, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME)
   Function FileTimeToSystemTime& (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME)
   Function SystemTimeToFileTime& (lpSystemTime As SYSTEMTIME, lpFileTime As FILETIME)

   Function DeleteFileA% (F$)
   Function RemoveDirectoryA% (F$)
   Function CreateDirectoryA% (F$, Byval X&&)
   Function SetCurrentDirectoryA% (f$)
   Function CloseHandle& (ByVal hfile As _Offset)
   Function GetLastError& ()
   Function FormatMessageA& (ByVal f As Long, f$, Byval e As Long, Byval d As Long, g$, Byval s As Long, h$)

   Function MultiByteToWideChar& (ByVal codePage~&, Byval dwFlags~&, lpszMbstring$, Byval byteCount&, lpwszWcstring$, Byval wideCount&)
   Function WideCharToMultiByte& (ByVal codePage~&, Byval dwFlags~&, lpWideString$, Byval ccWideChar%, lpMultiByte$, Byval multibyte%, Byval defaultchar&, Byval usedchar&)
   Function MoveFileW (f$, g$)
End Declare

Declare Library
   Function GetFileAttributes& (f$)
   Function SetFileAttributes& (f$, Byval a&)
   Function GetDriveType& (d$)
   Function GetShortPathName& (InP$, OutP$, Byval length&)
   Function GetModuleFileNameA (ByVal Module As Long, FileName As String, Byval nSize As Long)
   Function MoveFile (f$, g$)
   Function CopyFile (f$, g$, Byval f%)

   Function EncryptFile (f$)
   Function DecryptFile (f$, Byval f&)
   Function EncryptFileA (f$)
   Function DecryptFileA (f$, Byval f&)
End Declare

Declare Dynamic Library "advapi32"
   Function FileEncryptionStatusA% (f$, f&)
End Declare

Declare Dynamic Library "user32"
   Function SendMessageA%& (ByVal hWnd%&, Byval Msg~&, Byval wParam~%&, Byval lParam%&)
End Declare

Declare CustomType Library
   Function CreateFileA& (filename$, Byval access&, Byval sharing&, Byval sec_attr%&, Byval create&, Byval flags&, Byval template%&)
End Declare

Declare Function DisplayWinError$ (x)

' constant declarations (can be changed up to maxint)
Const Nul = ""
Const MaxArrays = 128
Const MaxChainRecurse = 16
Const MaxIncludeRecurse = 10
Const MaxFNlength = 1024
Const MaxFunctions = 26
Const MaxHistory = 10
Const MaxLines = 32000
Const MaxLoop = 255
Const MaxNestGosub = 128
Const MaxRecurse = 16
Const MaxViolations = 1024
Dim Shared WhiteSpace As String

' multi-dimensional command history arrays
Dim Shared HistoryCount2(0 To 5) As Integer
Dim Shared History2(0 To 5, 1 To MaxHistory) As String * 256

' multi-dimensional command history variable
Dim Shared Temp0 As Integer

' constant moreprompt declarations (could be changed)
Const MorePrompt1 = "More(y/n/c)?"
Const MorePrompt2 = "More(y/n)?"
Const MorePrompt3 = "(y/n/q)?"
Const MorePrompt4 = "-more-"
Dim Shared PageLength As Integer

' declare prompt strings
Dim Shared ControlBreak As Integer
Dim Shared MakeBeep As Integer
Dim Shared PromptStore As String
Dim Shared PromptLine As Integer
Dim Shared Quote As String * 1

' declare library variables.
Dim Shared finddata As WIN32_FIND_DATAA
Dim Shared hfind As _Offset
Dim Shared SysTime As SYSTEMTIME
Dim Shared DriveType As String

Dim Shared CurrentDirectory As String
Dim Shared Current.Drive As String * 1
Dim Shared NetPathError As Integer
Dim Shared Out3 As String
Dim Shared StatusLine1 As Double
Dim Shared StatusLine2 As Double
Dim Shared StatusLineFileSize As Double
Dim Shared t1 As Integer
Dim Shared t10 As Integer
Dim Shared t12 As Integer

' sound settings
Const Freq = 900
Const Duration = 6

MakeBeep = -1
Quote = Chr$(34)
WhiteSpace = Chr$(32) + Chr$(9) ' can be changed

' start control-break timer trap.
CurrentDirectory = _CWD$
t1 = _FreeTimer
On Timer(t1, 1) GoSub TimerTrap
Timer(t1) On
VarQ = _Exit
t10 = _FreeTimer
On Timer(t10, 1) Edit.Status.Line
Timer(t10) On
t12 = _FreeTimer
On Timer(t12, 1) CPUtrap
Timer(t12) On

' start menu
_Title "Menu Editor"
Call Menu3
Call StopProgram
End

' critical error trap
ErrorRoutine:
Print "Critical error "; Err
End

' timer ctrl-break trap.
TimerTrap:
VarQ = _Exit

' Alt-F4/windows X
If VarQ = 1 Then
   Call StopProgram
End If

' control-break
If VarQ = 2 Then
   ControlBreak = -1
   ' trap ctrl-c
   While InKey$ <> ""
      _Limit 50
      Eat$ = InKey$
   Wend
End If

' both windows X and ctrl-break
If VarQ = 3 Then
   Call StopProgram
End If
Return

Sub StopProgram
   Color 7, 0
   Timer(t1) Off
   Timer(t10) Off
   Timer(t12) Off
   ChDir CurrentDirectory
   End
End Sub

' simple file edit menu
Sub Menu3
   On Error GoTo ErrorRoutine
   Dim Attribute As Integer
   Dim ASCIIZ As String * 260
   Dim finddata4 As WIN32_FIND_DATAA
   Dim Wfile.Handle As _Offset
   Dim hfind4 As _Offset
   Current.Drive = Left$(_CWD$, 1)
   PageLength = 23
   Temp0 = 0
   Locate 24, 1, 1
   cx$ = _CWD$ ' store current drive/directory
   Do
      Color Yellow
      Print "Main Options for ";
      Color Red
      Print _CWD$
      Color White
      Print "  (C)ount specs"
      Print "  (D)irectory"
      Print "  (F)iles"
      Print "  (V)olume"
      Print "  (S)ystem"
      Print "  (Q)uit"
      Color Yellow
      PromptStore$ = "Enter option(?=help):"
      Print "Enter option(?=help):";
      Color White
      Do
         _Limit 50
         Locate , , 1
         x$ = INKEYx$
         If Len(x$) Then
            Print
            Exit Do
         End If
      Loop
      If UCase$(x$) = "Q" Then
         Color 7
         ' restore current drive/directory
         f$ = cx$ + Chr$(0)
         x = SetCurrentDirectoryA(f$)
         Exit Sub
      End If
      Select Case UCase$(x$)
         Case "?"
            'Filename = "menu3.doc"
            Call ListHelpFile("menu3.doc")
         Case "C"
            Color White
            Q# = CountBytes#("*.*")
            x# = CountFiles("*.*")
            Y# = CountDirs("*.*")
            Z = CountDrives
            Z1$ = CountDriveLetters
            Print _CWD$
            Print "Drives:"; Z; "("; Z1$; ")"
            Print "Dirs: "; FormatString$(Y#)
            Print "Files: "; FormatString$(x#)
            Print "Bytes: "; FormatString$(Q#)
            Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
         Case "S"
            Do
               Color Yellow
               Print "System Options for: ";
               Color Red
               If Left$(_CWD$, 2) = "\\" Then
                  Print _CWD$
               Else
                  Print Left$(_CWD$, 3)
               End If
               Color White
               Print "  (C)pu load"
               Print "  (S)ystem RAM"
               Print "  (P)aging RAM"
               Print "  (V)irtual RAM"
               Print "  (Q)uit"
               Color Yellow
               Print "Enter option?";
               Color White
               Do
                  _Limit 50
                  Locate , , 1
                  x$ = INKEYx$
                  If Len(x$) Then
                     Print
                     Exit Do
                  End If
               Loop
               If UCase$(x$) = "Q" Then Exit Do
               Select Case UCase$(x$)
                  Case "C"
                     Color Yellow
                     S$ = Str$(Int(GetCPULoad * 10000) / 100) ' 100.00
                     If InStr(S$, ".") Then
                        Q$ = Mid$(S$, InStr(S$, ".") + 1)
                        S$ = Left$(S$, InStr(S$, ".") - 1)
                        Q$ = Left$(Q$, 3)
                        S$ = S$ + "." + Q$
                     Else
                        S$ = S$ + ".0"
                     End If
                     Print "CPU " + S$ + "%" ' 100.00
                     Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                  Case "S"
                     Color Yellow
                     Print "Total Physical Memory: "; FormatString$(CDbl(TotalPhysicalMem))
                     Print "Free Physical Memory: "; FormatString$(CDbl(FreePhysicalMem))
                     Used# = CDbl(TotalPhysicalMem) - CDbl(FreePhysicalMem)
                     Print "Used Physical Memory: "; FormatString$(Used#)
                     Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                  Case "P"
                     Color Yellow
                     Print "Total Paging File: "; FormatString$(CDbl(TotalPagingFile))
                     Print "Free Paging File: "; FormatString$(CDbl(FreePagingFile))
                     Used# = CDbl(TotalPagingFile) - CDbl(FreePagingFile)
                     Print "Used Paging File: "; FormatString$(Used#)
                     Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                  Case "V"
                     Color Yellow
                     Print "Total Virtual Memory: "; FormatString$(CDbl(TotalVirtualMem))
                     Print "Free Virtual Memory: "; FormatString$(CDbl(FreeVirtualMem))
                     Used# = CDbl(TotalVirtualMem) - CDbl(FreeVirtualMem)
                     Print "Used Virtual Memory: "; FormatString$(Used#)
                     Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
               End Select
            Loop
         Case "D"
            Do
               Color Yellow
               Print "Directory Options for: ";
               Color Red
               Print _CWD$;
               Color Green
               x# = CountDirs("*.*")
               Print " ["; LTrim$(Str$(x#)); " dirs]"
               Color White
               Print "  (C)reate directory"
               Print "  (L)ist directories"
               Print "  (R)emove directory"
               Print "  (S)et current directory"
               Print "  (V)erify duplicates"
               Print "  (X)search directories"
               Print "  (Q)uit"
               Color Yellow
               Print "Enter option?";
               Color White
               Do
                  _Limit 50
                  Locate , , 1
                  x$ = INKEYx$
                  If Len(x$) Then
                     Print
                     Exit Do
                  End If
               Loop
               If UCase$(x$) = "Q" Then Exit Do
               Select Case UCase$(x$)
                  Case "X"
                     Color White
                     prompt$ = "Enter dir spec(*.*)? "
                     f$ = KeyboardLine3$(prompt$)
                     Call ListFiles(f$, False)
                     Call MorePrompt(MorePrompt4, "y " + Chr$(13), Output.Char$)
                  Case "V"
                     Color White
                     prompt$ = "Enter first path? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        Color White
                        prompt$ = "Enter second path? "
                        g$ = KeyboardLine3$(prompt$)
                        If g$ <> "" Then
                           If _DirExists(f$) And _DirExists(g$) Then
                              Call VerifyFiles(f$, g$)
                           Else
                              Color White
                              Print "Path not found."
                              Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                           End If
                        End If
                     End If
                  Case "L"
                     prompt$ = "Enter directory spec? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        LineCount = 0
                        LineBreak = PageLength
                        Quit = 0
                        ' start directory search
                        ASCIIZ = f$ + Chr$(0)
                        Wfile.Handle = FindFirstFileA(_Offset(ASCIIZ), _Offset(finddata4))
                        If Wfile.Handle <> INVALID_HANDLE_VALUE Then
                           Do
                              Attribute = finddata4.dwFileAttributes
                              ' check for directory
                              If (Attribute And &H10) = &H10 Then
                                 ' store directory name
                                 Directory$ = finddata4.cFileName
                                 Directory$ = Left$(Directory$, InStr(Directory$, Chr$(0)) - 1)
                                 ' check directory name
                                 If Directory$ <> "." And Directory$ <> ".." Then
                                    Print Directory$
                                    LineCount = LineCount + 1
                                    If LineCount >= LineBreak Then
                                       LineCount = 0
                                       Call MorePrompt(MorePrompt2, "yn " + Chr$(13), Outpt$)
                                       If Outpt$ = "n" Then
                                          Exit Do
                                       End If
                                    End If
                                 End If
                              End If
                           Loop While FindNextFileA(Wfile.Handle, _Offset(finddata4))
                           x = FindClose(Wfile.Handle)
                           If LineCount Then
                              Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                           End If
                        Else
                           Color White
                           Print "File not found."
                        End If
                     End If
                  Case "C"
                     prompt$ = "Enter directory? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        x = CreateDirectoryStructure(f$)
                        Color Yellow
                        If x = 0 Then
                           If NetPathError Then
                              Print "Netpath error."
                           Else
                              Print "Error 0x" + Hex$(GetLastError) + " creating directory."
                              VarQ$ = DisplayWinError$(x)
                              If Len(VarQ$) Then
                                 Print VarQ$
                              End If
                           End If
                        Else
                           Print "Directory created."
                        End If
                        Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                     End If
                  Case "R"
                     prompt$ = "Enter directory? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        Color Yellow
                        If _DirExists(f$) = 0 Then
                           Print "Directory not found."
                        Else
                           Print "Delete directory " + Chr$(34) + f$ + Chr$(34) + " and all filenames(y/n)? ";
                           Do
                              _Limit 50
                              x$ = InKey$
                              If LCase$(x$) = "y" Then Print: DeleteDir = -1: Exit Do
                              If LCase$(x$) = "n" Then Print: DeleteDir = 0: Exit Do
                           Loop
                           If DeleteDir Then
                              If Right$(f$, 1) <> "\" Then f$ = f$ + "\"
                              Call Silentdel_Directories(f$)
                              If _DirExists(f$) = 0 Then
                                 Print "Directory deleted."
                              Else
                                 Print "Error deleting directory."
                              End If
                              Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                           End If
                        End If
                     End If
                  Case "S"
                     prompt$ = "Enter directory? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        f$ = f$ + Chr$(0)
                        x = SetCurrentDirectoryA(f$)
                        Color Yellow
                        If x = 0 Then
                           Print "Error 0x" + Hex$(GetLastError) + " changing directory."
                           VarQ$ = DisplayWinError$(x)
                           If Len(VarQ$) Then
                              Print VarQ$
                           End If
                        Else
                           Print "Directory changed."
                        End If
                        Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                     End If
               End Select
            Loop
         Case "F"
            Do
               Color Yellow
               Print "File Options: ";
               Color Red
               Var# = CountFiles("*.*")
               Print "("; LTrim$(Str$(Var#)); " files)"
               Color White
               Print "  (A)ppend file"
               Print "  (B)yte compare"
               Print "  (C)opy file"
               Print "  (D)elete file"
               Print "  (E)ncrypt file"
               Print "  (F)ile editor"
               Print "  (G)et filesize"
               Print "  (L)ist files"
               Print "  (M)ake file"
               Print "  (R)ename file"
               Print "  (S)et attributes"
               Print "  (T)est file"
               Print "  (U)nencrypt file"
               Print "  (V)erify files"
               Print "  (X)search files"
               Print "  (Q)uit"
               Color Yellow
               PromptStore$ = "Enter option?"
               Print "Enter option?";
               Color White
               Do
                  _Limit 50
                  Locate , , 1
                  x$ = INKEYx$
                  If Len(x$) Then
                     Print
                     Exit Do
                  End If
               Loop
               If UCase$(x$) = "Q" Then Exit Do
               Select Case UCase$(x$)
                  Case "F"
                     Color White
                     prompt$ = "Enter filename? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        If _FileExists(f$) Then
                           'Call ResetScreen
                           Call Scrnedit(f$)
                        Else
                           g$ = f$ + Chr$(0)
                           hfind4 = CreateFileA(g$, &H180, 0, 0, 1, 0, 0)
                           Color Yellow
                           If hfind4 <> INVALID_HANDLE_VALUE Then
                              x = CloseHandle(hfind4)
                              'Call ResetScreen
                              Call Scrnedit(f$)
                           Else
                              Color White
                              Print "File not created."
                              Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                           End If
                        End If
                     Else
                        Color White
                        Print "File not found."
                        Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                     End If
                  Case "X"
                     Color White
                     prompt$ = "Enter file spec(*.*)? "
                     f$ = KeyboardLine3$(prompt$)
                     Call ListFiles(f$, True)
                     Call MorePrompt(MorePrompt4, "y " + Chr$(13), Output.Char$)
                  Case "B"
                     Color White
                     prompt$ = "Enter first file? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        Color White
                        prompt$ = "Enter second file? "
                        g$ = KeyboardLine3$(prompt$)
                        If g$ <> "" Then
                           If _FileExists(f$) And _FileExists(g$) Then
                              Call VerifyFiles2(f$, g$, -1)
                           Else
                              Color White
                              Print "File not found."
                              Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                           End If
                        End If
                     End If
                  Case "V"
                     Color White
                     prompt$ = "Enter first file? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        Color White
                        prompt$ = "Enter second file? "
                        g$ = KeyboardLine3$(prompt$)
                        If g$ <> "" Then
                           If _FileExists(f$) And _FileExists(g$) Then
                              Call VerifyFiles2(f$, g$, 0)
                           Else
                              Color White
                              Print "File not found."
                              Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                           End If
                        End If
                     End If
                  Case "G"
                     prompt$ = "Enter filename? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        ASCIIZ = f$ + Chr$(0)
                        Wfile.Handle = FindFirstFileA(_Offset(ASCIIZ), _Offset(finddata4))
                        If Wfile.Handle <> INVALID_HANDLE_VALUE Then
                           File.Size# = finddata4.nFileSizeHigh * &H100000000~&& Or finddata4.nFileSizeLow
                           Print FormatString$(File.Size#); " bytes."
                           x = FindClose(Wfile.Handle)
                        Else
                           Color White
                           Print "File not found."
                        End If
                        Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                     End If
                  Case "S"
                     prompt$ = "Enter filename? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        ASCIIZ = f$ + Chr$(0)
                        Wfile.Handle = FindFirstFileA(_Offset(ASCIIZ), _Offset(finddata4))
                        If Wfile.Handle <> INVALID_HANDLE_VALUE Then
                           Attribute = finddata4.dwFileAttributes
                           x = FindClose(Wfile.Handle)
                           ' check for directory
                           If (Attribute And &H10) <> &H10 Then
                              Do
                                 Color Yellow
                                 Print "Attributes:"
                                 Color White
                                 Print "  (1)Read-Only ";
                                 If (Attribute And &H1) = &H1 Then
                                    Print "<set>"
                                 Else
                                    Print "<off>"
                                 End If
                                 Print "  (2)Hidden ";
                                 If (Attribute And &H2) = &H2 Then
                                    Print "<set>"
                                 Else
                                    Print "<off>"
                                 End If
                                 Print "  (3)System ";
                                 If (Attribute And &H4) = &H4 Then
                                    Print "<set>"
                                 Else
                                    Print "<off>"
                                 End If
                                 Print "  (4)Archive ";
                                 If (Attribute And &H20) = &H20 Then
                                    Print "<set>"
                                 Else
                                    Print "<off>"
                                 End If
                                 Print "  (Q)uit"
                                 Color Yellow
                                 Print "Enter option?";
                                 Color White
                                 Do
                                    _Limit 50
                                    Locate , , 1
                                    x$ = INKEYx$
                                    If Len(x$) Then
                                       Print
                                       Exit Do
                                    End If
                                 Loop
                                 If UCase$(x$) = "Q" Then Exit Do
                                 Select Case x$
                                    Case "1"
                                       Attribute = Attribute Xor &H1
                                    Case "2"
                                       Attribute = Attribute Xor &H2
                                    Case "3"
                                       Attribute = Attribute Xor &H4
                                    Case "4"
                                       Attribute = Attribute Xor &H20
                                 End Select
                              Loop
                              ' change filename attribute
                              x = SetFileAttributes&(ASCIIZ, Attribute)
                           Else
                              Color White
                              Print "Specified directory."
                              Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                           End If
                        Else
                           Color White
                           Print "File not found."
                           Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                        End If
                     End If
                  Case "L"
                     prompt$ = "Enter file spec? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        LineCount = 0
                        LineBreak = PageLength
                        Quit = 0
                        ' start directory search
                        ASCIIZ = f$ + Chr$(0)
                        Wfile.Handle = FindFirstFileA(_Offset(ASCIIZ), _Offset(finddata4))
                        If Wfile.Handle <> INVALID_HANDLE_VALUE Then
                           Do
                              Attribute = finddata4.dwFileAttributes
                              ' check for directory
                              If (Attribute And &H10) <> &H10 Then
                                 ' store directory name
                                 Directory$ = finddata4.cFileName
                                 Directory$ = Left$(Directory$, InStr(Directory$, Chr$(0)) - 1)
                                 ' check directory name
                                 If Directory$ <> "." And Directory$ <> ".." Then
                                    Print Directory$
                                    LineCount = LineCount + 1
                                    If LineCount >= LineBreak Then
                                       LineCount = 0
                                       Call MorePrompt(MorePrompt2, "yn " + Chr$(13), Outpt$)
                                       If Outpt$ = "n" Then
                                          Exit Do
                                       End If
                                    End If
                                 End If
                              End If
                           Loop While FindNextFileA(Wfile.Handle, _Offset(finddata4))
                           x = FindClose(Wfile.Handle)
                           If LineCount Then
                              Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                           End If
                        Else
                           Color White
                           Print "File not found."
                        End If
                     End If
                  Case "T"
                     prompt$ = "Enter filename? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        f$ = f$ + Chr$(0)
                        x = FileEncryptionStatusA(f$, f&)

                        'FileEncryptionStatus return variable:

                        '0 = can be encrypted
                        '1 = file is encrypted
                        '2 = file is a system file (cannot be encrypted)
                        '3 = file is root (cannot be encryped)
                        '4 = file is system directory (cannot be encrypted)
                        '5 = encryption status unknown. file may be encrypted
                        '6 = file system does not support file encryption
                        '7 = reserved
                        '8 = file is read-only

                        If x = 0 Then
                           Print "Error 0x" + Hex$(GetLastError) + " accessing file."
                           VarQ$ = DisplayWinError$(x)
                           If Len(VarQ$) Then
                              Print VarQ$
                           End If
                        End If
                        If x Then
                           Select Case f&
                              Case 0
                                 Print "File can be encrypted."
                              Case 1
                                 Print "File is encrypted."
                              Case 2
                                 Print "File is system."
                              Case 3
                                 Print "File is root."
                              Case 4
                                 Print "File is system directory."
                              Case 5
                                 Print "Encryption status unknown."
                              Case 6
                                 Print "File system does not support encryption."
                              Case 7 ' reserved
                              Case 8
                                 Print "File is read-only."
                           End Select
                        End If
                        Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                     End If
                  Case "E"
                     prompt$ = "Enter filename? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        f$ = f$ + Chr$(0)
                        x = EncryptFile(f$)
                        Color Yellow
                        If x = 0 Then
                           Print "Error 0x" + Hex$(GetLastError) + " encrypting file."
                           VarQ$ = DisplayWinError$(x)
                           If Len(VarQ$) Then
                              Print VarQ$
                           End If
                        Else
                           Print "File encrypted."
                        End If
                        Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                     End If
                  Case "U"
                     prompt$ = "Enter filename? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        f$ = f$ + Chr$(0)
                        x = DecryptFile(f$, 0) ' 0=reserved
                        Color Yellow
                        If x = 0 Then
                           Print "Error 0x" + Hex$(GetLastError) + " decrypting file."
                           VarQ$ = DisplayWinError$(x)
                           If Len(VarQ$) Then
                              Print VarQ$
                           End If
                        Else
                           Print "File decrypted."
                        End If
                        Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                     End If
                  Case "D"
                     prompt$ = "Enter filename? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        f$ = f$ + Chr$(0)
                        x = DeleteFileA(f$)
                        Color Yellow
                        If x = 0 Then
                           Print "Error 0x" + Hex$(GetLastError) + " deleting file."
                           VarQ$ = DisplayWinError$(x)
                           If Len(VarQ$) Then
                              Print VarQ$
                           End If
                        Else
                           Print "File deleted."
                        End If
                        Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                     End If
                  Case "A"
                     prompt$ = "Enter filename? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        f$ = f$ + Chr$(0)
                        hfind4 = CreateFileA(f$, &H180, 0, 0, 4, 0, 0)
                        Color Yellow
                        If hfind4 <> INVALID_HANDLE_VALUE Then
                           Print "File handle" + Str$(hfind4) + " accessed for append."
                           x = CloseHandle(hfind4)
                        Else
                           Print "Error 0x" + Hex$(GetLastError) + " appending file."
                           VarQ$ = DisplayWinError$(x)
                           If Len(VarQ$) Then
                              Print VarQ$
                           End If
                        End If
                        Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                     End If
                  Case "M"
                     prompt$ = "Enter filename? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        f$ = f$ + Chr$(0)
                        hfind4 = CreateFileA(f$, &H180, 0, 0, 1, 0, 0)
                        Color Yellow
                        If hfind4 <> INVALID_HANDLE_VALUE Then
                           Print "File handle" + Str$(hfind4) + " created."
                           x = CloseHandle(hfind4)
                        Else
                           Print "Error 0x" + Hex$(GetLastError) + " creating file."
                           VarQ$ = DisplayWinError$(x)
                           If Len(VarQ$) Then
                              Print VarQ$
                           End If
                        End If
                        Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                     End If
                  Case "R"
                     Color White
                     prompt$ = "Enter filename? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        Color White
                        prompt$ = "Enter new filename? "
                        g$ = KeyboardLine3$(prompt$)
                        If g$ <> "" Then
                           f$ = f$ + Chr$(0)
                           g$ = g$ + Chr$(0)
                           x = MoveFile(f$, g$)
                           Color Yellow
                           If x = 0 Then
                              Print "Error 0x" + Hex$(GetLastError) + " renaming filename."
                              VarQ$ = DisplayWinError$(x)
                              If Len(VarQ$) Then
                                 Print VarQ$
                              End If
                           Else
                              Print "Filename renamed."
                           End If
                           Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                        End If
                     End If
                  Case "C"
                     Color White
                     prompt$ = "Enter source filename? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        Color White
                        prompt$ = "Enter dest filename? "
                        g$ = KeyboardLine3$(prompt$)
                        If g$ <> "" Then
                           f$ = f$ + Chr$(0)
                           g$ = g$ + Chr$(0)
                           x = CopyFile(f$, g$, 0) ' 0=overwrite, -1=don't
                           Color Yellow
                           If x = 0 Then
                              Print "Error 0x" + Hex$(GetLastError) + " copying filename."
                              VarQ$ = DisplayWinError$(x)
                              If Len(VarQ$) Then
                                 Print VarQ$
                              End If
                           Else
                              Print "Filename copied."
                           End If
                           Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                        End If
                     End If
               End Select
            Loop
         Case "V"
            Do
               Color Yellow
               Print "Volume Options for: ";
               Color Red
               If Left$(_CWD$, 2) = "\\" Then
                  Print _CWD$;
               Else
                  c$ = Left$(_CWD$, 1)
                  Call Vlabel(c$)
                  If RTrim$(c$) = "" Then
                     z$ = DriveType
                  Else
                     z$ = Left$(c$, 12)
                  End If
                  Print Left$(_CWD$, 2) + z$;
               End If
               Color Green
               x = CountDrives
               Print " ["; LTrim$(Str$(x)); " drives]"
               Color White
               Print "  (C)hange volume"
               Print "  (D)isplay serial"
               Print "  (G)et system type"
               Print "  (L)ist volume"
               Print "  (R)ead disk space"
               Print "  (S)et drive"
               Print "  (V)iew drives"
               Print "  (X)search volume"
               Print "  (Q)uit"
               Color Yellow
               PromptStore$ = "Enter option?"
               Print "Enter option?";
               Color White
               Do
                  _Limit 50
                  Locate , , 1
                  x$ = INKEYx$
                  If Len(x$) Then
                     Print
                     Exit Do
                  End If
               Loop
               If UCase$(x$) = "Q" Then Exit Do
               Color Yellow
               Select Case UCase$(x$)
                  Case "X"
                     prompt$ = "Enter drive volume? "
                     g$ = KeyboardLine3$(prompt$)
                     g$ = UCase$(g$)
                     If g$ <> "" Then
                        Found = 0
                        For f = 1 To 26
                           f$ = UCase$(Chr$(f + 64))
                           v = GetDriveExists(f$)
                           If v Then
                              ' get drive info.                                    VarX$ = f$ + ":\" + CHR$(0)
                              Out3$ = ""
                              VarX$ = f$ + ":\" + Chr$(0)
                              Vname$ = Space$(MAX_PATH)
                              Fname$ = Space$(MAX_PATH)
                              R = GetVolumeInformationA(VarX$, Vname$, MAX_PATH, serial~&, empty1~&, empty2~&, Fname$, MAX_PATH)
                              If R Then
                                 ' get volume label.
                                 Out3$ = RTrim$(Vname$)
                                 v = InStr(Out3$, Chr$(0))
                                 If v Then
                                    Out3$ = Left$(Out3$, v - 1)
                                    Call InstrSUB1(Flag, g$, Out3$, 0)
                                    If Flag Then
                                       Print f$; ":";
                                       Print Out3$
                                       Found = -1
                                    End If
                                 End If
                              End If
                           End If
                        Next
                        If Found = 0 Then
                           Print "No drive volumes found."
                        End If
                        Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                     End If
                  Case "V"
                     Q = 0
                     prompt$ = "Enter drive list(<enter>=all)? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ = "" Then
                        'prompt$ = "Enter drive array(0-26)? "
                        'g$ = KeyboardLine3$(prompt$)
                        'v = Int(Val(g$))
                        'If v >= 0 And v <= 26 Then
                        'Q = v
                        'End If
                     End If
                     Call ListDrives(f$, 0) ' list all specified drives
                     Call MorePrompt(MorePrompt4, "y " + Chr$(13), Output.Char$)
                  Case "S"
                     prompt$ = "Enter drive letter? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        f$ = UCase$(f$)
                        z$ = f$
                        If f$ >= "A" And f$ <= "Z" Then
                           v = GetDriveExists(f$)
                           If v Then
                              f$ = f$ + ":\" + Chr$(0)
                              x = SetCurrentDirectoryA(f$)
                              Color Yellow
                              If x = 0 Then
                                 Print "Error 0x" + Hex$(GetLastError) + " changing drive."
                                 VarQ$ = DisplayWinError$(x)
                                 If Len(VarQ$) Then
                                    Print VarQ$
                                 End If
                              Else
                                 Print "Drive "; z$; ": changed."
                              End If
                           Else
                              Print "Drive "; z$; ": not found."
                           End If
                        Else
                           Print "Drive "; z$; ": not found."
                        End If
                        Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                     End If
                  Case "D"
                     prompt$ = "Enter drive letters? "
                     z$ = KeyboardLine3$(prompt$)
                     If z$ <> "" Then
                        For VX = 1 To Len(z$)
                           f$ = UCase$(Mid$(z$, VX, 1))
                           If f$ >= "A" And f$ <= "Z" Then
                              v = GetDriveExists(f$)
                              If v Then
                                 ' get drive info.                                    VarX$ = f$ + ":\" + CHR$(0)
                                 Out3$ = ""
                                 Vname$ = Space$(MAX_PATH)
                                 Fname$ = Space$(MAX_PATH)
                                 VarX$ = f$ + ":\" + Chr$(0)
                                 R = GetVolumeInformationA(VarX$, Vname$, MAX_PATH, serial~&, empty1~&, empty2~&, Fname$, MAX_PATH)
                                 If R Then
                                    ' get serial number.
                                    Out3$ = Left$(Hex$(serial~&), 4) + "-" + Right$(Hex$(serial~&), 4)
                                    Print f$; ":"; Out3$
                                 Else
                                    Print "Media "; f$; ": not inserted."
                                 End If
                              Else
                                 Print "Drive "; f$; ": not found."
                              End If
                           Else
                              Print "Invalid "; f$; ": drive eltter."
                           End If
                        Next
                        Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                     End If
                  Case "G"
                     prompt$ = "Enter drive letters? "
                     z$ = KeyboardLine3$(prompt$)
                     If z$ <> "" Then
                        For VX = 1 To Len(z$)
                           f$ = UCase$(Mid$(z$, VX, 1))
                           If f$ >= "A" And f$ <= "Z" Then
                              v = GetDriveExists(f$)
                              If v Then
                                 ' get drive info.                                    VarX$ = f$ + ":\" + CHR$(0)
                                 Out3$ = ""
                                 Vname$ = Space$(MAX_PATH)
                                 Fname$ = Space$(MAX_PATH)
                                 VarX$ = f$ + ":\" + Chr$(0)
                                 R = GetVolumeInformationA(VarX$, Vname$, MAX_PATH, serial~&, empty1~&, empty2~&, Fname$, MAX_PATH)
                                 If R Then
                                    ' get system type.
                                    Out3$ = RTrim$(Fname$)
                                    Print f$; ":"; Out3$
                                 Else
                                    Print "Media "; f$; ": not inserted."
                                 End If
                              Else
                                 Print "Drive "; f$; ": not found."
                              End If
                           Else
                              Print "Invalid "; f$; ": drive eltter."
                           End If
                        Next
                        Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                     End If
                  Case "R"
                     prompt$ = "Enter drive letters? "
                     z$ = KeyboardLine3$(prompt$)
                     If z$ <> "" Then
                        VarQ = 0
                        For VX = 1 To Len(z$)
                           f$ = UCase$(Mid$(z$, VX, 1))
                           If f$ >= "A" And f$ <= "Z" Then
                              v = GetDriveExists(f$)
                              If v Then
                                 ' get drive info.                                    VarX$ = f$ + ":\" + CHR$(0)
                                 Out3$ = ""
                                 Vname$ = Space$(MAX_PATH)
                                 Fname$ = Space$(MAX_PATH)
                                 VarX$ = f$ + ":\" + Chr$(0)
                                 R = GetVolumeInformationA(VarX$, Vname$, MAX_PATH, serial~&, empty1~&, empty2~&, Fname$, MAX_PATH)
                                 If R Then
                                    ' get drive space.
                                    R = GetDiskFreeSpaceExA(VarX$, free~&&, total~&&, free2~&&)
                                    If R Then
                                       Color Yellow
                                       Print "Drive "; f$; ":"
                                       Color White
                                       Print "Total: "; FormatString$(CDbl(total~&&))
                                       Print "Free: "; FormatString$(CDbl(free~&&))
                                       Used# = total~&& - free~&&
                                       Print "Used: "; FormatString$(Used#)
                                       VarQ = -1
                                       Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                                    Else
                                       Print "Disk ;"; f$; ": space unavailable."
                                       VarQ = -1
                                       Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                                    End If
                                 Else
                                    Print "Media "; f$; ": not inserted."
                                    VarQ = -1
                                    Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                                 End If
                              Else
                                 Print "Drive "; f$; ": not found."
                                 VarQ = -1
                                 Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                              End If
                           Else
                              Print "Invalid "; f$; ": drive letter."
                              VarQ = -1
                              Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                           End If
                        Next
                        If VarQ = 0 Then
                           Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                        End If
                     End If
                  Case "L"
                     prompt$ = "Enter drive letters? "
                     z$ = KeyboardLine3$(prompt$)
                     If z$ <> "" Then
                        For VX = 1 To Len(z$)
                           f$ = UCase$(Mid$(z$, VX, 1))
                           If f$ >= "A" And f$ <= "Z" Then
                              v = GetDriveExists(f$)
                              If v Then
                                 Print f$; ":";
                                 ' get drive info.                                    VarX$ = f$ + ":\" + CHR$(0)
                                 Out3$ = ""
                                 VarX$ = f$ + ":\" + Chr$(0)
                                 Vname$ = Space$(MAX_PATH)
                                 Fname$ = Space$(MAX_PATH)
                                 R = GetVolumeInformationA(VarX$, Vname$, MAX_PATH, serial~&, empty1~&, empty2~&, Fname$, MAX_PATH)
                                 If R Then
                                    ' get volume label.
                                    Out3$ = RTrim$(Vname$)
                                    v = InStr(Out3$, Chr$(0))
                                    If v Then Out3$ = Left$(Out3$, v - 1)
                                 End If
                                 If RTrim$(Out3$) = "" Then
                                    Print DriveType
                                 Else
                                    Print Out3$; " "; DriveType
                                 End If
                              Else
                                 Print "Drive "; f$; ": not found."
                                 Exit For
                              End If
                           Else
                              Print "Invalid "; f$; ": drive letter."
                              Exit For
                           End If
                        Next
                        Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                     End If
                  Case "C"
                     prompt$ = "Enter drive letter? "
                     f$ = KeyboardLine3$(prompt$)
                     If f$ <> "" Then
                        f$ = UCase$(f$)
                        z$ = f$
                        If f$ >= "A" And f$ <= "Z" Then
                           v = GetDriveExists(f$)
                           If v Then
                              ' get drive info.
                              VarX$ = f$ + ":\" + Chr$(0)
                              Vname$ = Space$(MAX_PATH)
                              Fname$ = Space$(MAX_PATH)
                              R = GetVolumeInformationA(VarX$, Vname$, MAX_PATH, serial~&, empty1~&, empty2~&, Fname$, MAX_PATH)
                              If R Then
                                 OK = -1
                                 prompt$ = "Enter drive volume? "
                                 g$ = KeyboardLine3$(prompt$)
                                 If g$ = Nul Then
                                    v$ = "Are you sure you want to remove the volume label(y/n)? "
                                    Call MorePrompt(v$, "yn", Outpt$)
                                    If Outpt$ = "n" Then
                                       OK = 0
                                    End If
                                 End If
                                 If OK Then
                                    ' change volume label
                                    f$ = f$ + ":\" + Chr$(0)
                                    g$ = g$ + Chr$(0)
                                    x = SetVolumeLabelA%(f$, g$)
                                    ' check volume flag
                                    If x = 0 Then
                                       Print "Error 0x" + Hex$(GetLastError) + " naming volume."
                                       VarQ$ = DisplayWinError$(x)
                                       If Len(VarQ$) Then
                                          Print VarQ$
                                       End If
                                    Else
                                       Print "Volume "; z$; ": changed."
                                    End If
                                 Else
                                    Print "Volume "; z$; ": unchanged."
                                 End If
                              Else
                                 Print "Media "; z$; ": not inserted."
                              End If
                           Else
                              Print "Drive "; z$; ": not found."
                           End If
                        Else
                           Print "Invalid "; z$; ": drive letter."
                        End If
                        Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
                     End If
               End Select
            Loop
      End Select
   Loop
End Sub

Function FileCompare (Path1$, Path2$, Filename1$, Filename2$)
   'Dim Byte1 As String * 1
   'Dim Byte2 As String * 1
   FileComp1$ = Path1$
   If Right$(FileComp1$, 1) <> "\" Then
      FileComp1$ = FileComp1$ + "\"
   End If
   FileComp1$ = FileComp1$ + Filename1$

   FileComp2$ = Path2$
   If Right$(FileComp2$, 1) <> "\" Then
      FileComp2$ = FileComp2$ + "\"
   End If
   FileComp2$ = FileComp2$ + Filename2$

   If _FileExists(FileComp1$) = 0 Then
      FileCompare = 0
      Exit Function
   End If

   If _FileExists(FileComp2$) = 0 Then
      FileCompare = 0
      Exit Function
   End If
   ' check file buffers
   X = FreeFile
   Open FileComp1$ For Random Shared As #X Len = 1024
   Field #X, 1024 As X$
   Y = FreeFile
   Open FileComp2$ For Random Shared As #Y Len = 1024
   Field #Y, 1024 As Y$
   Do
      If EOF(X) Then Exit Do
      Get #X: Get #Y
      If X$ <> Y$ Then
         Close #X, #Y
         FileCompare = 0
         Exit Function
      End If
   Loop
   Close #X, #Y
   FileCompare = -1
End Function

Sub VerifyFiles (Var1$, Var2$)
   Dim Attribute As Integer
   Dim ASCIIZ As String * 260
   Dim finddata4 As WIN32_FIND_DATAA
   Dim Wfile.Handle As _Offset

   Dim Verify1(1) As String
   Dim Verify2(1) As String
   Dim VerifyCount1 As Single
   Dim VerifyCount2 As Single
   VerifyCount1 = 0!
   VerifyCount2 = 0!

   Dim SizeArray1(1) As Double
   Dim SizeArray2(1) As Double

   ' make search path
   Var3$ = Var1$
   If Right$(Var3$, 1) <> "\" Then
      Var3$ = Var3$ + "\"
   End If
   TempPath1$ = Var3$
   Var3$ = Var3$ + "*.*"

   Var4$ = Var2$
   If Right$(Var4$, 1) <> "\" Then
      Var4$ = Var4$ + "\"
   End If
   TempPath2$ = Var4$
   Var4$ = Var4$ + "*.*"

   ' store first path files
   ASCIIZ = Var3$ + Chr$(0)
   Wfile.Handle = FindFirstFileA(_Offset(ASCIIZ), _Offset(finddata4))
   If Wfile.Handle <> INVALID_HANDLE_VALUE Then
      Do
         Attribute = finddata4.dwFileAttributes
         ' check for directory
         If (Attribute And &H10) <> &H10 Then
            ' store directory name
            Directory$ = finddata4.cFileName
            Directory$ = Left$(Directory$, InStr(Directory$, Chr$(0)) - 1)
            ' check directory name
            If Directory$ <> "." And Directory$ <> ".." Then
               VerifyCount1 = VerifyCount1 + 1!
               ReDim _Preserve Verify1(VerifyCount1) As String
               Verify1(VerifyCount1) = Directory$

               ReDim _Preserve SizeArray1(VerifyCount1) As Double
               SizeArray1(VerifyCount1) = finddata4.nFileSizeHigh * &H100000000~&& Or finddata4.nFileSizeLow

            End If
         End If
      Loop While FindNextFileA(Wfile.Handle, _Offset(finddata4))
      x = FindClose(Wfile.Handle)
   End If

   ' store second path files
   ASCIIZ = Var4$ + Chr$(0)
   Wfile.Handle = FindFirstFileA(_Offset(ASCIIZ), _Offset(finddata4))
   If Wfile.Handle <> INVALID_HANDLE_VALUE Then
      Do
         Attribute = finddata4.dwFileAttributes
         ' check for directory
         If (Attribute And &H10) <> &H10 Then
            ' store directory name
            Directory$ = finddata4.cFileName
            Directory$ = Left$(Directory$, InStr(Directory$, Chr$(0)) - 1)
            ' check directory name
            If Directory$ <> "." And Directory$ <> ".." Then
               VerifyCount2 = VerifyCount2 + 1!
               ReDim _Preserve Verify2(VerifyCount2) As String
               Verify2(VerifyCount2) = Directory$

               ReDim _Preserve SizeArray2(VerifyCount2) As Double
               SizeArray2(VerifyCount2) = finddata4.nFileSizeHigh * &H100000000~&& Or finddata4.nFileSizeLow

            End If
         End If
      Loop While FindNextFileA(Wfile.Handle, _Offset(finddata4))
      x = FindClose(Wfile.Handle)
   End If

   ' check files found
   If VerifyCount1 = 0! Or VerifyCount2 = 0! Then
      Color White
      Print "No matching files found."
      Exit Sub
   End If

   ' compare both arrays
   LineCount = 3
   LineBreak = PageLength
   Found = 0
   Color White
   Print "Comparing "; Var3$; " to "; Var4$
   For Var1! = 1! To VerifyCount1
      For Var2! = 1! To VerifyCount2
         If Verify1(Var1!) = Verify2(Var2!) Then
            If SizeArray1(Var1!) = SizeArray2(Var2!) Then
               If FileCompare(Var1$, Var2$, Verify1(Var1!), Verify2(Var2!)) Then
                  If Found = 0 Then
                     Color White
                     Print "Filename1", "Filename2", "Filesize"
                     Print "---------", "---------", "--------"
                  End If
                  Found = -1
                  Color Yellow
                  ' force to 8.3
                  File1$ = Ambiguate$(TempPath1$ + Verify1(Var1!))
                  If File1$ = Nul Then File1$ = Verify1(Var1!)
                  File2$ = Ambiguate$(TempPath2$ + Verify2(Var2!))
                  If File2$ = Nul Then File2$ = Verify2(Var2!)
                  ' strip path
                  File1$ = Ambiguate2$(File1$)
                  File1$ = Left$(File1$, 12)
                  File2$ = Ambiguate2$(File2$)
                  File2$ = Left$(File2$, 12)
                  ' display matching files
                  Print UCase$(File1$), UCase$(File2$), FormatString$(SizeArray1(Var1!))
                  LineCount = LineCount + 1
                  If LineCount >= LineBreak Then
                     LineCount = 0
                     Color White
                     Call MorePrompt(MorePrompt2, "yn " + Chr$(13), Outpt$)
                     If Outpt$ = "n" Then
                        Exit Sub
                     End If
                  End If
               End If
            End If
         End If
      Next
   Next
   If Found = 0 Then
      Color White
      Print "No matching files found."
   End If
   If LineCount Then
      Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
   End If
End Sub

Sub VerifyFiles2 (Var1$, Var2$, VarX)
   Dim Byte1 As String * 1
   Dim Byte2 As String * 1
   X = FreeFile
   Open Var1$ For Binary Shared As #X Len = 1
   Y = FreeFile
   Open Var2$ For Binary Shared As #Y Len = 1
   If LOF(X) <> LOF(Y) Then
      Print "Files not same size."
      Close X, Y
      Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
      Exit Sub
   End If

   LineCount = 3
   LineBreak = PageLength

   Z# = 0#
   Close X, Y
   X = FreeFile
   Open Var1$ For Random Shared As #X Len = 1024
   Field #X, 1024 As x$
   Y = FreeFile
   Open Var2$ For Random Shared As #Y Len = 1024
   Field #Y, 1024 As y$
   T# = 1#
   VX = 0
   ' read both files in 1K blocks.
   Do
      If EOF(X) Then Exit Do
      Get #X: Get #Y
      If x$ <> y$ Then
         If VarX Then
            If VX = 0 Then
               Color White
               Print "Comparing "; Var1$; " to "; Var2$
               Print "Offset         Byte Hex    ASCII"
               Print "-------------  ---- -----  -------"
            End If
            VX = -1
            GoSub DisplayX
         Else
            Print "Files do not match."
            Close #X, #Y
            Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
            Exit Sub
         End If
      End If
      T# = T# + 1024#
   Loop
   Close #X, #Y
   If VX = 0 Then
      Print "Files match."
      Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
   Else
      If LineCount Then
         Call MorePrompt(MorePrompt4, " " + Chr$(13), Outpt$)
      End If
   End If
   Exit Sub
   ' display bytes compared in block.
   DisplayX:
   For Q = 1 To 1024
      Byte1 = Mid$(x$, Q, 1)
      Byte2 = Mid$(y$, Q, 1)
      Z# = T# + Q - 1 ' store block plus byte.
      If Byte1 <> Byte2 Then
         _ControlChr Off
         V1$ = LTrim$(Str$(Z#)): V1$ = V1$ + Space$(15 - Len(V1$))
         Color Yellow: Print V1$;
         V1$ = Byte1
         Color Red: Print V1$;
         Color White: Print "\";
         V1$ = Byte2 + "  "
         Color Red: Print V1$;
         V2$ = Right$("00" + Hex$(Asc(Byte1)), 2) + "\" + Right$("00" + Hex$(Asc(Byte2)), 2)
         V3$ = Right$("000" + LTrim$(Str$(Asc(Byte1))), 3) + "\" + Right$("000" + LTrim$(Str$(Asc(Byte2))), 3)
         VX$ = V2$ + "  " + V3$
         Color Green: Print VX$
         _ControlChr On
         LineCount = LineCount + 1
         If LineCount >= LineBreak Then
            LineCount = 0
            Call MorePrompt(MorePrompt2, "yn " + Chr$(13), Outpt$)
            If Outpt$ = "n" Then
               Exit For
            End If
         End If
      End If
   Next
   Return
End Sub

' prompts for multiple input characters
Sub MorePrompt (InputString$, InputMask$, OutputString$)
   Color White, Black
   If InputString$ = MorePrompt4 Then
      Print InputString$;
   Else
      Print InputString$; " ";
   End If
   InputChar$ = Nul
   Do
      _Limit 50
      Locate , , 1
      InputChar$ = LCase$(InKey$)
      If ControlBreak Then
         Print
         Color MoreBreakColor, Black
         Print MoreBreakMessage
         Color White, Black
         If InputString$ = MorePrompt4 Then
            Print InputString$;
         Else
            Print InputString$; " ";
         End If
         ControlBreak = False
      End If
      If Len(InputChar$) Then
         If InputChar$ = "?" Then
            If Len(InputMask$) < 10 Then
               Call DisplayPromptHelp(InputString$)
               Color White, Black
               If InputString$ = MorePrompt4 Then
                  Print InputString$;
               Else
                  Print InputString$; " ";
               End If
            End If
         Else
            If InStr(InputMask$, InputChar$) Then
               If InputChar$ = Chr$(13) Then
                  Print
               Else
                  Print InputChar$
               End If
               OutputString$ = InputChar$
               Exit Do
            End If
         End If
      End If
   Loop
End Sub

Function INKEYx$
   X$ = InKey$
   If Len(X$) Then
      INKEYx$ = X$
      KeyPressed = -1
   End If
End Function

' uses direct keyboard input to get an input line
'   and edit multi-dimensional command history arrays with line-wrapping,
'     where Temp0 (history array type) equals:
'       0=none
'       1=prompt
'       2=<n/a>

Function KeyboardLine2$ (Prompt$)
   VarX$ = Prompt$
   ControlBreak = 0
   If Temp0 > 0 Then
      HistoryCount2(Temp0) = 0 ' reset
   End If
   Color White
   Var$ = Nul
   Do
      _Limit 50
      If ControlBreak Then
         GoSub EraseLine
         Print
         Color BreakColor, Black
         Print BreakMessage
         If MakeBeep Then
            Sound Freq, Duration
         End If
         ControlBreak = 0
         Color Yellow, Black
         Locate , , 1
         Print VarX$;
         Var$ = ""
      End If
      Var2$ = InKey$ ' get character
      If Len(Var2$) Then
         Select Case Len(Var2$)
            Case 1
               Select Case Var2$
                  Case Chr$(3) ' ctrl-c
                     Eat$ = Nul
                  Case Chr$(9) ' tab
                     If Len(Var$) + 8 <= 256 Then
                        For VarX = 1 To 8
                           Print " ";
                           Locate , , Visible
                           Var$ = Var$ + " "
                        Next
                     End If
                  Case Chr$(13) ' return
                     If Temp0 > 0 Then
                        GoSub EnterHistory
                     End If
                     Exit Do
                  Case Chr$(8) ' backspace
                     If Len(Var$) > 0 Then
                        Var$ = Left$(Var$, Len(Var$) - 1)
                        GoSub BackSpace
                     End If
                  Case Chr$(27) ' escape
                     GoSub EraseLine
                  Case Else ' store input
                     If Len(Var$) < 256 Then
                        _ControlChr Off
                        Print Var2$;
                        _ControlChr On
                        Locate , , Visible
                        Var$ = Var$ + Var2$
                     End If
               End Select
            Case 2
               Select Case Asc(Right$(Var2$, 1))
                  Case 82 ' insert
                     Ascii$ = Nul
                     GoSub DisplayAsciiLine
                     Do
                        _Limit 50
                        Var3$ = InKey$
                        If ControlBreak Then
                           Ascii$ = Nul
                           ControlBreak = False
                           Exit Do
                        End If
                        If Var3$ = Chr$(13) Then ' return
                           Exit Do
                        End If
                        If Var3$ = Chr$(27) Then ' escape
                           Var3$ = Nul
                           If Len(Ascii$) Then
                              Ascii$ = Nul
                              GoSub DisplayAsciiLine
                           End If
                        End If
                        If Var3$ = Chr$(8) Then ' backspace
                           Var3$ = Nul
                           If Len(Ascii$) Then
                              Ascii$ = Left$(Ascii$, Len(Ascii$) - 1)
                              GoSub DisplayAsciiLine
                           End If
                        End If
                        If LCase$(Var3$) = "x" Or LCase$(Var3$) = "o" Or LCase$(Var3$) = "b" Then
                           If Len(Ascii$) = 0 Then
                              Ascii$ = Ascii$ + LCase$(Var3$)
                              GoSub DisplayAsciiLine
                           End If
                        End If
                        If LCase$(Var3$) >= "a" And LCase$(Var3$) <= "f" Then
                           If Len(Ascii$) >= 1 And Len(Ascii$) < 3 Then
                              If Left$(Ascii$, 1) = "x" Then
                                 Ascii$ = Ascii$ + Var3$
                                 GoSub DisplayAsciiLine
                              End If
                           End If
                        End If
                        If Left$(Ascii$, 1) = "o" Then
                           If Var3$ >= "0" And Var3$ <= "7" Then
                              If Len(Ascii$) < 4 Then
                                 Ascii$ = Ascii$ + Var3$
                                 GoSub DisplayAsciiLine
                              End If
                           End If
                        Else
                           If Left$(Ascii$, 1) = "b" Then
                              If Var3$ = "0" Or Var3$ = "1" Then
                                 If Len(Ascii$) < 9 Then
                                    Ascii$ = Ascii$ + Var3$
                                    GoSub DisplayAsciiLine
                                 End If
                              End If
                           Else
                              If Var3$ >= "0" And Var3$ <= "9" Then
                                 If Len(Ascii$) < 3 Then
                                    Ascii$ = Ascii$ + Var3$
                                    GoSub DisplayAsciiLine
                                 End If
                              End If
                           End If
                        End If
                     Loop

                     ' insert ascii character
                     If Left$(Ascii$, 1) = "x" Then ' hexidecimal
                        AsciiValue = Int(Val("&H" + Mid$(Ascii$, 2)))
                     Else
                        If Left$(Ascii$, 1) = "o" Then ' octal
                           AsciiValue = Int(Val("&O" + Mid$(Ascii$, 2)))
                        Else
                           If Left$(Ascii$, 1) = "b" Then ' binary
                              Ascii$ = Mid$(Ascii$, 2)
                              GoSub BinaryString
                           Else
                              AsciiValue = Int(Val(Ascii$))
                           End If
                        End If
                     End If
                     If AsciiValue >= 0 And AsciiValue <= 255 Then
                        If AsciiValue = 10 Or AsciiValue = 13 Then
                           Eat$ = Nul
                        Else
                           If Len(Var$) < 256 Then
                              Var$ = Var$ + Chr$(AsciiValue)
                           End If
                        End If
                     End If
                     Locate PromptLine, 1, 1
                     Color White, Black
                     _ControlChr Off
                     Print Var$;
                     _ControlChr On
                  Case 77 ' right
                     If Temp0 > 0 Then
                        GoSub GetCount
                        If Var1 > 0 Then
                           Select Case HistoryCount2(Temp0)
                              Case 0
                                 GoSub EraseLine
                                 HistoryCount2(Temp0) = Var1
                                 Var$ = RTrim$(History2(Temp0, Var1))
                                 _ControlChr Off
                                 Print Var$;
                                 _ControlChr On
                              Case 1 TO MaxHistory - 1
                                 If HistoryCount2(Temp0) + 1 <= Var1 Then
                                    GoSub EraseLine
                                    HistoryCount2(Temp0) = HistoryCount2(Temp0) + 1
                                    Var$ = RTrim$(History2(Temp0, HistoryCount2(Temp0)))
                                    _ControlChr Off
                                    Print Var$;
                                    _ControlChr On
                                 Else
                                    If HistoryCount2(Temp0) = Var1 Then
                                       GoSub EraseLine
                                       Var$ = RTrim$(History2(Temp0, Var1))
                                       _ControlChr Off
                                       Print Var$;
                                       _ControlChr On
                                    End If
                                 End If
                              Case MaxHistory
                                 GoSub EraseLine
                                 Var$ = RTrim$(History2(Temp0, MaxHistory))
                                 _ControlChr Off
                                 Print Var$;
                                 _ControlChr On
                           End Select
                        End If
                     End If
                  Case 75 ' left
                     If Temp0 > 0 Then
                        GoSub GetCount
                        If Var1 > 0 Then
                           Select Case HistoryCount2(Temp0)
                              Case 0
                                 GoSub EraseLine
                                 HistoryCount2(Temp0) = Var1
                                 Var$ = RTrim$(History2(Temp0, Var1))
                                 _ControlChr Off
                                 Print Var$;
                                 _ControlChr On
                              Case 1
                                 GoSub EraseLine
                                 Var$ = RTrim$(History2(Temp0, 1))
                                 _ControlChr Off
                                 Print Var$;
                                 _ControlChr On
                              Case Else
                                 If HistoryCount2(Temp0) - 1 > 0 Then
                                    GoSub EraseLine
                                    HistoryCount2(Temp0) = HistoryCount2(Temp0) - 1
                                    Var$ = RTrim$(History2(Temp0, HistoryCount2(Temp0)))
                                    _ControlChr Off
                                    Print Var$;
                                    _ControlChr On
                                 End If
                           End Select
                        End If
                     End If
                  Case 71 ' home
                     If Temp0 > 0 Then
                        GoSub GetCount
                        If Var1 > 0 Then
                           GoSub EraseLine
                           HistoryCount2(Temp0) = 1
                           Var$ = RTrim$(History2(Temp0, 1))
                           _ControlChr Off
                           Print Var$;
                           _ControlChr On
                        End If
                     End If
                  Case 79 ' end
                     If Temp0 > 0 Then
                        GoSub GetCount
                        If Var1 > 0 Then
                           GoSub EraseLine
                           HistoryCount2(Temp0) = Var1
                           Var$ = RTrim$(History2(Temp0, Var1))
                           _ControlChr Off
                           Print Var$;
                           _ControlChr On
                        End If
                     End If
               End Select
         End Select
      End If
   Loop

   ' return input line
   KeyboardLine2$ = Var$
   Exit Function

   EnterHistory:
   If Temp0 = 0 Then
      Return
   End If
   If Len(Var$) Then
      GoSub GetCount
      ' init
      If Var1 = 0 Then
         HistoryCount2(Temp0) = 1
         History2(Temp0, 1) = Var$
      Else
         ' add history
         If HistoryCount2(Temp0) = 0 Then
            If Var1 < MaxHistory Then
               HistoryCount2(Temp0) = Var1 + 1
               History2(Temp0, Var1 + 1) = Var$
            Else
               For Var = 1 To MaxHistory - 1
                  History2(Temp0, Var) = History2(Temp0, Var + 1)
               Next
               HistoryCount2(Temp0) = MaxHistory
               History2(Temp0, MaxHistory) = Var$
            End If
         Else
            ' pack history
            If Var1 = MaxHistory Then
               For Var = HistoryCount2(Temp0) To MaxHistory - 1
                  History2(Temp0, Var) = History2(Temp0, Var + 1)
               Next
               HistoryCount2(Temp0) = MaxHistory
               History2(Temp0, MaxHistory) = Var$
            Else
               For Var = HistoryCount2(Temp0) To Var1 - 1
                  History2(Temp0, Var) = History2(Temp0, Var + 1)
               Next
               History2(Temp0, Var1) = Var$
            End If
         End If
      End If
   End If
   Return

   BinaryString:
   AsciiValue = False
   BinaryPower = False
   For BinaryDigit = Len(Ascii$) To 1 Step -1
      OutX$ = Mid$(Ascii$, BinaryDigit, 1)
      Select Case OutX$
         Case "0"
            ' nul
         Case "1"
            AsciiValue = AsciiValue + 2 ^ BinaryPower
      End Select
      BinaryPower = BinaryPower + 1
   Next
   Return

   DisplayAsciiLine:
   Color White, Blue
   Locate 25, 1, 1
   If Left$(Ascii$, 1) = "x" Then
      Var2$ = "Enter 2-digit ascii code: " + Ascii$
   Else
      If Left$(Ascii$, 1) = "o" Then
         Var2$ = "Enter 3-digit ascii code: " + Ascii$
      Else
         If Left$(Ascii$, 1) = "b" Then
            Var2$ = "Enter 8-digit ascii code: " + Ascii$
         Else
            Var2$ = "Enter 3-digit ascii code: " + Ascii$
         End If
      End If
   End If
   VarC = Len(Var2$) + 1
   Var2$ = Var2$ + Space$(80 - Len(Var2$))
   Print Var2$;
   Locate 25, VarC, 1
   Return

   EraseLine:
   For VarX = 1 To Len(Var$)
      GoSub BackSpace
   Next
   Var$ = Nul
   Return

   BackSpace:
   If Pos(0) > 1 Then ' check cursor location
      Locate CsrLin, Pos(0) - 1, 0
      Print " ";
      Locate CsrLin, Pos(0) - 1, Visible
   Else ' line-wrap
      Locate CsrLin - 1, ScreenWidth, 0
      Print " ";
      Locate CsrLin - 1, ScreenWidth, Visible
   End If
   Return

   GetCount:
   Var1 = 0
   For Var2 = MaxHistory To 1 Step -1
      If RTrim$(History2(Temp0, Var2)) <> Nul Then
         Var1 = Var2
         Exit For
      End If
   Next
   Return
End Function

' special keyboard input function
Function KeyboardLine3$ (Prompt$)
   Visible = 1
   Color Yellow, Black
   Locate , 1, 1
   PromptLine = CsrLin
   Print Prompt$;
   PromptStore = Prompt$
   Locate , , 1
   Temp0 = 1 ' turn on history
   KeyboardLine3$ = KeyboardLine2$(Prompt$)
   Print
End Function

' count bytes
Function CountBytes# (Ext$)
   Dim ASCIIZ4 As String * 260
   Found# = 0#

   ' reset search parameter
   Var4$ = _CWD$
   If Right$(Var4$, 1) <> "\" Then
      Var4$ = Var4$ + "\"
   End If
   If Ext$ = "" Then
      Var4$ = Var4$ + "*.*"
   Else
      Var4$ = Var4$ + Ext$
   End If

   ASCIIZ4 = Var4$ + Chr$(0)
   hfind = FindFirstFileA(_Offset(ASCIIZ4), _Offset(finddata))
   If hfind <> INVALID_HANDLE_VALUE Then
      Do
         ' check longfilename
         z$ = finddata.cFileName
         vx = InStr(z$, Chr$(0))
         If vx Then
            z$ = Left$(z$, vx - 1)
         End If
         If z$ = Nul Then
            Eat$ = Nul
         Else
            If z$ = "." Or z$ = ".." Then
               Eat$ = Nul
            Else
               Var# = finddata.dwFileAttributes
               If (Var# And &H10) = &H0 Then
                  VarZ# = finddata.nFileSizeHigh * &H100000000~&& Or finddata.nFileSizeLow
                  Found# = Found# + VarZ#
               End If
            End If
         End If
      Loop While FindNextFileA(hfind, _Offset(finddata))
      x = FindClose(hfind)
   End If
   CountBytes# = Found#
End Function

' count files
Function CountFiles# (Ext$)
   Dim ASCIIZ4 As String * 260
   Found# = 0#

   ' reset search parameter
   Var4$ = _CWD$
   If Right$(Var4$, 1) <> "\" Then
      Var4$ = Var4$ + "\"
   End If
   If Ext$ = "" Then
      Var4$ = Var4$ + "*.*"
   Else
      Var4$ = Var4$ + Ext$
   End If

   ASCIIZ4 = Var4$ + Chr$(0)
   hfind = FindFirstFileA(_Offset(ASCIIZ4), _Offset(finddata))
   If hfind <> INVALID_HANDLE_VALUE Then
      Do
         ' check longfilename
         z$ = finddata.cFileName
         vx = InStr(z$, Chr$(0))
         If vx Then
            z$ = Left$(z$, vx - 1)
         End If
         If z$ = Nul Then
            Eat$ = Nul
         Else
            If z$ = "." Or z$ = ".." Then
               Eat$ = Nul
            Else
               Var# = finddata.dwFileAttributes
               If (Var# And &H10) = &H0 Then
                  Found# = Found# + 1#
               End If
            End If
         End If
      Loop While FindNextFileA(hfind, _Offset(finddata))
      x = FindClose(hfind)
   End If
   CountFiles# = Found#
End Function

' count dirs
Function CountDirs# (Ext$)
   Dim ASCIIZ4 As String * 260
   Found# = 0#

   ' reset search parameter
   Var4$ = _CWD$
   If Right$(Var4$, 1) <> "\" Then
      Var4$ = Var4$ + "\"
   End If
   If Ext$ = "" Then
      Var4$ = Var4$ + "*.*"
   Else
      Var4$ = Var4$ + Ext$
   End If

   ASCIIZ4 = Var4$ + Chr$(0)
   hfind = FindFirstFileA(_Offset(ASCIIZ4), _Offset(finddata))
   If hfind <> INVALID_HANDLE_VALUE Then
      Do
         ' check longfilename
         z$ = finddata.cFileName
         vx = InStr(z$, Chr$(0))
         If vx Then
            z$ = Left$(z$, vx - 1)
         End If
         If z$ = Nul Then
            Eat$ = Nul
         Else
            If z$ = "." Or z$ = ".." Then
               Eat$ = Nul
            Else
               Var# = finddata.dwFileAttributes
               If (Var# And &H10) = &H10 Then
                  Found# = Found# + 1#
               End If
            End If
         End If
      Loop While FindNextFileA(hfind, _Offset(finddata))
      x = FindClose(hfind)
   End If
   CountDirs# = Found#
End Function

' count drives
Function CountDriveLetters$
   v$ = Nul
   For c = 1 To 26
      If DRIVEEXISTS(c) = 0 Then
         v$ = v$ + Chr$(c + 64)
      End If
   Next
   CountDriveLetters = v$
End Function

' count drives
Function CountDrives%
   v = 0
   For c = 1 To 26
      If DRIVEEXISTS(c) = 0 Then
         v = v + 1
      End If
   Next
   CountDrives = v
End Function

' formats a double numeric string
Function FormatString$ (s#)
   x$ = Nul
   s$ = Str$(s#)
   If InStr(s$, "D") Then ' return string
      FormatString$ = s$
      Exit Function
   End If
   If Left$(s$, 1) = "-" Then ' store sign
      e$ = "-"
      s$ = Mid$(s$, 2)
   End If
   s$ = LTrim$(s$) ' format string
   If InStr(s$, ".") Then
      q$ = Mid$(s$, InStr(s$, "."))
      s$ = Left$(s$, InStr(s$, ".") - 1)
   End If
   For l = Len(s$) To 3 Step -3
      x$ = Mid$(s$, l - 2, 3) + "," + x$
   Next
   If l > 0 Then
      x$ = Mid$(s$, 1, l) + "," + x$
   End If
   If Len(s$) < 3 Then
      x$ = s$
   End If
   If Right$(x$, 1) = "," Then
      x$ = Left$(x$, Len(x$) - 1)
   End If
   x$ = e$ + x$ + q$ ' construct string
   FormatString$ = x$
End Function

' check drive exists.
'  returns -1 if drive not detected.
Function DRIVEEXISTS (V)
   VarX$ = Chr$(V + 64) + ":\" + Chr$(0)
   VarX = GetDriveType(VarX$)
   DriveType = ""
   ' drives A: and B: default to floppy
   If DriveType = "" Then
      If V = 1 Or V = 2 Then
         DriveType = "[FLOPPY]"
         DRIVEEXISTS = 0
         Exit Function
      End If
   End If
   Select Case VarX
      Case 0
         DriveType = "[UNKNOWN]"
      Case 1
         DriveType = "[BADROOT]"
      Case 2
         DriveType = "[REMOVABLE]"
      Case 3
         DriveType = "[FIXED]"
      Case 4
         DriveType = "[REMOTE]"
      Case 5
         DriveType = "[CDROM]"
      Case 6
         DriveType = "[RAMDISK]"
   End Select
   If VarX > 1 Then
      DRIVEEXISTS = 0
   Else
      DRIVEEXISTS = -1
   End If
End Function

' check netpath exists.
'  returns -1 if netpath not detected.
Function NETPATHEXISTS (Z$)
   VarX$ = Z$ + Chr$(0)
   VarX = GetDriveType(VarX$)
   If VarX > 1 Then
      NETPATHEXISTS = 0
   Else
      NETPATHEXISTS = -1
   End If
End Function

' function to match case-sensitive substring with ?, * characters in substring
'  Return Var = -1 if match
'  VarQ = -1 force case-sensitive
'  See if Var1$ exists in Var2$
Sub InstrSUB1 (Var, Var1$, Var2$, VarQ)

   ' store case-sensitive string match variables
   If VarQ Then
      S2$ = Var1$
      S3$ = Var2$
   Else
      S2$ = LCase$(Var1$)
      S3$ = LCase$(Var2$)
   End If

   ' check default instr
   If InStr(S2$, "*") = 0 Then
      If InStr(S2$, "?") = 0 Then
         Var = InStr(S3$, S2$)
         Exit Sub
      End If
   End If

   Var = -1 ' assume match

   ' see if S2$ matches in S3$ with substrings
   For S3 = 1 To Len(S3$)
      S1$ = Mid$(S3$, S3)
      P1 = 1 ' pointer to S1$
      P2 = 1 ' pointer to S2$
      Do
         ' check match
         If P2 > Len(S2$) Then
            Exit Sub
         End If

         ' check character in S2$ at P2
         V$ = Mid$(S2$, P2, 1)
         Select Case V$
            Case "*" ' global character
               ' scan to next char
               If P2 > Len(S2$) Then
                  Exit Do
               End If
               S4$ = Mid$(S2$, P2 + 1, 1)
               Select Case S4$
                  Case "*", "?"
                     P2 = P2 + 1
                  Case Else
                     Do
                        If Mid$(S1$, P1, 1) = S4$ Then
                           Exit Do
                        End If
                        If P1 >= Len(S1$) Then
                           Exit Do
                        End If
                        P1 = P1 + 1
                     Loop
                     P2 = P2 + 1
               End Select
            Case "?" ' wildcard character
               P1 = P1 + 1
               P2 = P2 + 1
            Case Else ' ascii character
               If Mid$(S1$, P1, 1) <> V$ Then ' no match
                  Exit Do
               End If
               P1 = P1 + 1
               P2 = P2 + 1
         End Select
      Loop
   Next
   Var = 0 ' no match
End Sub

' return -1 if drive exists
Function GetDriveExists (V$)
   VarX$ = V$ + ":\" + Chr$(0)
   VarX = GetDriveType(VarX$)
   DriveType = ""
   If V$ = "A" Or V$ = "B" Then
      DriveType = "[FLOPPY]"
      GetDriveExists = -1
      Exit Function
   End If
   Select Case VarX
      Case 0
         DriveType = "[UNKNOWN]"
      Case 1
         DriveType = "[BADROOT]"
      Case 2
         DriveType = "[REMOVABLE]"
      Case 3
         DriveType = "[FIXED]"
      Case 4
         DriveType = "[REMOTE]"
      Case 5
         DriveType = "[CDROM]"
      Case 6
         DriveType = "[RAMDISK]"
   End Select
   If VarX > 1 Then
      GetDriveExists = -1
   Else
      GetDriveExists = 0
   End If
End Function

' displays a help file
Sub ListHelpFile (Filename$)
   FileFound = _FileExists(Filename$)
   If FileFound = False Then
      Print "Helpfile " + Quote + Filename$ + Quote + " not found."
      Print "Set environment path variable to point at SIC64 files."
      Call MorePrompt(MorePrompt1, "ync", OutputChar$)
      Exit Sub
   End If
   FileNumber = FreeFile
   Open Filename$ For Input As #FileNumber
   Continuous = False
   LineCount = False
   Do While Not EOF(FileNumber)
      Color Yellow, Black
      Line Input #FileNumber, InputLine$
      GoSub ConvertColor
      If VarX Then
         GoTo NextHelpLine
      End If
      If Left$(LTrim$(InputLine$), 1) = ";" Then
         GoTo NextHelpLine
      End If
      If LCase$(InputLine$) = "<more>" Then
         Eat$ = Nul
      Else
         Print InputLine$
      End If
      If Continuous = False Then
         LineCount = LineCount + 1
         If LineCount = PageLength Or LCase$(InputLine$) = "<more>" Then
            LineCount = False
            Call MorePrompt(MorePrompt1, "ync" + Chr$(13), OutputChar$)
            Select Case OutputChar$
               Case "n"
                  Exit Do
               Case "c"
                  Continuous = True
            End Select
         End If
      End If
      NextHelpLine:
   Loop
   Call KeyPrompt
   Close #FileNumber
   FileNumber = False
   Exit Sub

   ConvertColor:
   VarX = 0
   VarX$ = LCase$(InputLine$)
   VarX$ = XTRIM$(VarX$, 0)
   Select Case VarX$
      Case "<color=gray>", "<color=8>"
         Color Gray
         VarX = -1
      Case "<color=blue>", "<color=9>"
         Color Blue
         VarX = -1
      Case "<color=green>", "<color=10>"
         Color Green
         VarX = -1
      Case "<color=cyan>", "<color=11>"
         Color Cyan
         VarX = -1
      Case "<color=red>", "<color=12>"
         Color Red
         VarX = -1
      Case "<color=magenta>", "<color=13>"
         Color Magenta
         VarX = -1
      Case "<color=yellow>", "<color=14>"
         Color Yellow
         VarX = -1
      Case "<color=white>", "<color=15>"
         Color White
         VarX = -1
   End Select
   Return
End Sub

' display dirs/files
'   VarQ = 0 for directories only
Sub ListFiles (VarZ$, VarQ)
   Dim ASCIIZ4 As String * 260

   If Compatible = 0 Then
      If LINUX Or MACOSX Then
         Error 175
         Exit Sub
      End If
   End If

   ErrorCount = 0
   ErrorType2 = -1

   ' reset search parameter
   If Len(VarZ$) Then
      Var4$ = VarZ$
   Else
      Var4$ = "*.*"
   End If

   ' display header
   Color White, Black
   Print "Searching: " + Var4$
   GoSub TitleHeader

   c = 0
   q = 0
   v = 1
   t = 0
   For l = 1 To 2 ' dirs/files
      If l = 2 Then
         If VarQ = 0 Then
            Exit For
         End If
      End If
      ASCIIZ4 = Var4$ + Chr$(0)
      hfind = FindFirstFileA(_Offset(ASCIIZ4), _Offset(finddata))
      If hfind <> INVALID_HANDLE_VALUE Then
         z = 0
         Do
            OK = 0
            Var# = finddata.dwFileAttributes
            If l = 1 Then
               If (Var# And &H10) = &H10 Then
                  OK = -1
               End If
            End If
            If l = 2 Then
               If (Var# And &H10) = &H0 Then
                  OK = -1
               End If
            End If

            X$ = finddata.cFileName
            VarX = InStr(X$, Chr$(0))
            If VarX Then
               X$ = Left$(X$, VarX - 1)
            End If
            X$ = RTrim$(X$)
            If X$ = "." Or X$ = ".." Then
               OK = 0
            End If
            If OK Then
               If t Then
                  t = 0
                  GoSub TitleHeader
               End If
               Attr$ = Space$(7)
               If l = 1 Then
                  Mid$(Attr$, 2, 1) = "D"
                  d1 = d1 + 1
               Else
                  f1 = f1 + 1
               End If
               q = -1

               ' print shortfilename
               z$ = finddata.cAlternateFileName
               vx = InStr(z$, Chr$(0))
               If vx Then
                  z$ = Left$(z$, vx - 1)
               End If
               If z$ = Nul Then
                  z$ = finddata.cFileName
                  vx = InStr(z$, Chr$(0))
                  If vx Then
                     z$ = Left$(z$, vx - 1)
                  End If
               End If
               If Len(z$) > 12 Then
                  z$ = Left$(z$, 12)
               End If
               Color Yellow, Black
               Print UCase$(z$);
               If Len(z$) <= 14 Then
                  Print Space$(14 - Len(z$));
               End If

               ' print date/time
               x& = FileTimeToSystemTime&(finddata.ftLastWriteTime, SysTime)
               Var$ = Right$("00" + LTrim$(Str$(SysTime.wMonth)), 2) + "-"
               Var$ = Var$ + Right$("00" + LTrim$(Str$(SysTime.wDay)), 2) + "-"
               Var$ = Var$ + LTrim$(Str$(SysTime.wYear)) + "  "
               Var$ = Var$ + Right$("00" + LTrim$(Str$(SysTime.wMonth)), 2) + "-"
               Var$ = Var$ + Right$("00" + LTrim$(Str$(SysTime.wDay)), 2) + "-"
               Var$ = Var$ + LTrim$(Str$(SysTime.wYear))
               Color Green, Black
               Print Var$;

               ' attributes of directory/filename
               Var# = finddata.dwFileAttributes
               If Var# < 0 Then
                  Var# = 0
               End If
               If (Var# And &H20) = &H20 Then
                  Mid$(Attr$, 1, 1) = "A" ' archive
               End If
               If (Var# And &H4) = &H4 Then
                  Mid$(Attr$, 3, 1) = "S" ' system
               End If
               If (Var# And &H2) = &H2 Then
                  Mid$(Attr$, 4, 1) = "H" ' hidden
               End If
               If (Var# And &H1) = &H1 Then
                  Mid$(Attr$, 5, 1) = "R" ' read-only
               End If
               If (Var# And &H800) = &H800 Then
                  Mid$(Attr$, 6, 1) = "C" ' compressed
               End If
               If (Var# And &H4000) = &H4000 Then
                  Mid$(Attr$, 7, 1) = "E" ' encrypted
               End If
               Color Red, Black
               Print " "; Attr$; " ";

               ' print filesize
               z$ = "<DIR>"
               If l = 2 Then
                  Var# = finddata.nFileSizeHigh * &H100000000~&&
                  Var# = Var# Or finddata.nFileSizeLow
                  VarX~&& = VarX~&& + Var# ' add bytes
                  Call Suffix(Var#, z$) ' 1,024.0 KB
               End If
               z$ = Left$(z$, 10)
               z$ = Space$(10 - Len(z$)) + z$
               Color Cyan, Black
               Print z$; " ";

               ' print longfilename
               z$ = finddata.cFileName
               VarX = InStr(z$, Chr$(0))
               If VarX Then
                  z$ = Left$(z$, VarX - 1)
               End If
               z$ = RTrim$(z$)
               If Len(z$) Then
                  If Len(z$) > 21 Then
                     z$ = Left$(z$, 20) + "..."
                  End If
                  Color Yellow, Black
                  Print z$;
               End If
               Print

               ' prompt
               v = v + 1
               If v = 21 Then
                  v = 0
                  If c = 0 Then
                     Color White, Black
                     Print MorePrompt4;
                     X$ = Nul
                     Do
                        _Limit 50
                        X$ = InKey$
                        If ControlBreak Then
                           ControlBreak = False
                           Exit Do
                        End If
                        If Len(X$) Then
                           Select Case LCase$(X$)
                              Case "c" ' continuous
                                 c = -1
                                 Exit Do
                              Case "n", "q" ' no/quit
                                 v = 0
                                 Print
                                 Exit For
                              Case " ", Chr$(13), "y" ' yes/continue
                                 Exit Do
                           End Select
                        End If
                     Loop
                     Print
                     t = -1
                  End If
               End If
            End If
         Loop While FindNextFileA(hfind, _Offset(finddata))
         x = FindClose(hfind)
      End If
   Next
   If q = 0 Then
      Color Yellow, Black
      Print None
   End If

   ' print totals
   Color White, Black
   Print "------------                                 ----------"
   TotalLine$ = "Files " + FormatString$(CDbl(f1))
   TotalLine$ = TotalLine$ + " Dirs " + FormatString$(CDbl(d1))
   TotalLine$ = Left$(TotalLine$, 40)
   TotalLine$ = TotalLine$ + Space$(44 - Len(TotalLine$))

   VarX# = CDbl(VarX~&&)
   Call Suffix(VarX#, z$) ' 1,024.0 KB
   TotalLine$ = TotalLine$ + Space$(11 - Len(z$)) + z$
   Print TotalLine$
   Exit Sub

   TitleHeader:
   Color White, Black
   Print "Filename      Date        Time       Attr          Size Longfilename"
   Print "------------  ----------  --------   -----   ---------- ------------"
   Return
End Sub

' lists specified drives
Sub ListDrives (Var$, VarQ)
   ' Var$ = "x..." only list drives in string
   ' VarQ = 0 list all drives, VarQ = 1 to 26

   If Compatible = 0 Then
      If LINUX Or MACOSX Then
         Error 175
         Exit Sub
      End If
   End If

   l = 0
   GoSub DriveHeader
   For c = 1 To 26
      If Var$ <> Nul Then ' display specific drives
         x$ = UCase$(Var$)
         If InStr(x$, Chr$(c + 64)) Then
            x = InStr(x$, Chr$(c + 64))
            x = Asc(Mid$(x$, x, 1))
            If x >= 65 And x <= 90 Then
               x = x - 64
               If c = x Then
                  GoSub DisplayDrive
               End If
            End If
         End If
      Else
         If VarQ = 0 Then ' display all drives
            GoSub DisplayDrive
         End If
      End If
      If h = 20 Then
         h = 0
         Call MorePrompt(MorePrompt4, "y " + Chr$(13), Output.Char$)
         GoSub DriveHeader
      End If
   Next
   If q = 0 Then
      Print "<none>"
   Else
      Color White, Black
      Print "Total drives"; l
   End If
   Exit Sub

   DisplayDrive:
   c$ = Chr$(c + 64)
   Out3 = c$
   If DRIVEEXISTS(c) = 0 Then
      h = h + 1
      l = l + 1
      q = -1

      ' display drive letter
      Color White, Black
      Print c$; ":    ";

      ' display volume label
      Color Yellow, Black
      Out3 = c$
      Call Vlabel(Out3)
      If RTrim$(Out3) = "" Then
         z$ = DriveType
      Else
         z$ = Left$(Out3, 12)
      End If
      z$ = z$ + Space$(13 - Len(z$))
      Print z$;

      ' display volume serial number
      Color Green, Black
      Out3 = c$
      Call Vserial(Out3)
      z$ = Left$(Out3, 12)
      z$ = z$ + Space$(13 - Len(z$))
      Print z$;

      ' display volume file system type
      Color Red, Black
      Out3 = c$
      Call Vtype(Out3)
      z$ = Left$(Out3, 8)
      z$ = z$ + Space$(9 - Len(z$))
      Print z$;

      ' display volume total disk space
      Color Cyan, Black
      Out3 = c$
      Call TotalSpace(Out3)
      x# = Int(Val(Out3))
      x1# = x#
      If x# > 0# Then
         Call Suffix(x#, S$) ' 1,024.0 KB
         Print Space$(11 - Len(S$)) + S$;
      Else
         Print "      <n/a>";
      End If

      ' display volume free disk space
      Out3 = c$
      Call FreeSpace(Out3)
      y# = Int(Val(Out3))
      y1# = y#
      If y# > 0# Then
         Call Suffix(y#, S$) ' 1,024.0 KB
         Print Space$(11 - Len(S$)) + S$;
      Else
         Print "      <n/a>";
      End If

      ' display volume used disk space
      If x1# > 0# Or y1# > 0# Then
         z# = x1# - y1#
         Call Suffix(z#, S$) ' 1,024.0 KB
         Print Space$(11 - Len(S$)) + S$
      Else
         Print "      <n/a>"
      End If
   End If
   Return

   DriveHeader:
   h = 2
   Color White, Black
   Print "Drive Label        Serial       Type           Total       Free       Used"
   Print "--------------------------------------------------------------------------"
   Return
End Sub

' routine to create directory structure
Function CreateDirectoryStructure (NewDirectory$)
   ' construct path
   NewDirectory$ = RTrim$(NewDirectory$)
   Next.Dest.Net$ = ""
   NetPathError = 0
   If Left$(NewDirectory$, 2) = "\\" Then ' \\serve\share\
      V = InStr(3, NewDirectory$, "\")
      If V Then
         V = InStr(V + 1, NewDirectory$, "\")
         If V Then
            Next.Dest.Net$ = Left$(NewDirectory$, V - 1)
            NewDirectory$ = Mid$(NewDirectory$, V + 1)
         End If
      End If
      If Next.Dest.Net$ = "" Then
         NetPathError = -1
         CreateDirectory = 0
         Exit Function
         NewDirectory$ = "\"
         Drive.Create$ = Current.Drive
      End If
   Else
      If Mid$(NewDirectory$, 2, 1) = ":" Then ' c:\tempx
         Drive.Create$ = Left$(NewDirectory$, 1)
         NewDirectory$ = Mid$(NewDirectory$, 3)
      Else
         If Left$(NewDirectory$, 1) = "\" Then ' \tempx
            Drive.Create$ = Left$(_CWD$, 1)
         Else
            If Left$(_CWD$, 2) = "\\" Then ' \\tempx
               Next.Dest.Net$ = _CWD$
            Else
               Drive.Create$ = Left$(_CWD$, 1) ' c:tempx
            End If
         End If
      End If
   End If
   If Right$(NewDirectory$, 1) <> "\" Then
      NewDirectory$ = NewDirectory$ + "\"
   End If

   ' create path
   x = 0
   Next.Dir = InStr(NewDirectory$, "\")
   Do
      If Next.Dir = False Then
         Exit Do
      End If

      ' parse path left to right
      SubDir$ = Left$(NewDirectory$, Next.Dir - 1) ' \tempx\t1\t2\t3\
      Next.Dir = InStr(Next.Dir + 1, NewDirectory$, "\")

      ' make directory name
      If Len(SubDir$) Then
         ' create directory
         If Len(Next.Dest.Net$) Then
            F$ = Next.Dest.Net$ + "\" + SubDir$
         Else
            F$ = Drive.Create$ + ":" + SubDir$
         End If

         ' check directory
         If _DirExists(F$) = 0 Then
            F$ = F$ + Chr$(0)
            x = CreateDirectoryA(F$, 0)

            ' check error
            If x = 0 Then
               If GetLastError& = &HB7 Then ' ignore already exists
                  ' nul
               Else
                  Exit Do
               End If
            End If
         End If
      End If
   Loop
   CreateDirectoryStructure = x
End Function

Sub Silentdel_Directories (Directory.Search$)
   ' declare subroutine variables
   Dim Attribute As _Unsigned Long
   Dim ASCIIZ As String * 260
   Dim finddata As WIN32_FIND_DATAA
   Dim Wfile.Handle As _Offset

   ' make directory filename
   ASCIIZ = Directory.Search$ + "*.*" + Chr$(0)

   ' start directory search
   Wfile.Handle = FindFirstFileA(_Offset(ASCIIZ), _Offset(finddata))
   If Wfile.Handle <> INVALID_HANDLE_VALUE Then

      ' delete filenames
      Call Silentdel_DeleteFiles(Directory.Search$)

      ' recurse subdirectories
      Do
         ' check directory attribute
         Attribute = finddata.dwFileAttributes

         ' check directory
         If (Attribute And &H10) = &H10 Then

            ' store directory name
            Directory$ = finddata.cFileName
            Directory$ = Left$(Directory$, InStr(Directory$, Chr$(0)) - 1)

            ' store short filename
            If InStr(Directory$, "?") Then
               Directory$ = finddata.cAlternateFileName
               V = InStr(Directory$, Chr$(0))
               If V Then Directory$ = Left$(Directory$, V - 1)
            End If

            ' check directory name
            If Directory$ <> "." And Directory$ <> ".." Then

               ' make next search directory
               Next.Directory$ = Directory.Search$ + Directory$ + "\"

               ' recursively search subdirectories
               Call Silentdel_Directories(Next.Directory$)
            End If
         End If
      Loop While FindNextFileA(Wfile.Handle, _Offset(finddata))
      x = FindClose(Wfile.Handle)
   End If

   ' delete directory
   Call Silentdel_DeleteDirectory(Directory.Search$)
End Sub

' subroutine to delete an empty directory
Sub Silentdel_DeleteDirectory (Directory$)
   ' declare subroutine variables
   Dim ASCIIZ As String * 260

   ' store directory filename
   ASCIIZ = Directory$ + Chr$(0)

   ' change directory attribute
   AttrX& = GetFileAttributes(ASCIIZ)
   AttrX& = AttrX& And Not &H1 ' remove read-only bit
   x = SetFileAttributes&(ASCIIZ, AttrX&)

   ' delete directory
   x = RemoveDirectoryA(ASCIIZ)
End Sub

' subroutine to delete files in a directory
Sub Silentdel_DeleteFiles (Directory$)
   ' declare subroutine variables
   Dim ASCIIZ As String * 260
   Dim ASCIIZ2 As String * 260
   Dim finddata As WIN32_FIND_DATAA
   Dim Wfile.Handle As _Offset

   ' make filename
   ASCIIZ = Directory$ + "*.*" + Chr$(0)

   Wfile.Handle = FindFirstFileA(_Offset(ASCIIZ), _Offset(finddata))
   If Wfile.Handle <> INVALID_HANDLE_VALUE Then

      ' filename loop
      Do
         ' store filename
         Filename$ = finddata.cFileName
         Filename$ = Left$(Filename$, InStr(Filename$, Chr$(0)) - 1)

         ' check filename
         If Filename$ <> "." And Filename$ <> ".." Then
            ' store filename
            ASCIIZ2 = Directory$ + Filename$ + Chr$(0)

            ' change filename attribute
            AttrX& = GetFileAttributes(ASCIIZ2)
            AttrX& = AttrX& And Not &H1 ' remove read-only bit
            x = SetFileAttributes&(ASCIIZ2, AttrX&)

            ' delete long filename
            x = DeleteFileA(ASCIIZ2)

            ' check error and delete 8.3 filename
            If x = 0 Then
               Short.Filename$ = finddata.cAlternateFileName
               V = InStr(Short.Filename$, Chr$(0))
               If V Then Short.Filename$ = Left$(Short.Filename$, V - 1)
               ASCIIZ2 = Directory$ + Short.Filename$ + Chr$(0)

               ' change filename attribute
               AttrX& = GetFileAttributes(ASCIIZ2)
               AttrX& = AttrX& And Not &H1
               x = SetFileAttributes&(ASCIIZ2, AttrX&)

               ' delete short filename
               x = DeleteFileA(ASCIIZ2)
            End If
         End If
      Loop While FindNextFileA(Wfile.Handle, _Offset(finddata))
      x = FindClose(Wfile.Handle)
   End If
End Sub

' main fullscreen editor
Sub Scrnedit (OutX$)
   Const Nul = ""
   Dim VarX As String * 1
   Dim VarY As String * 1
   Dim LineX As String
   Dim Max.Row As Integer
   Dim Temp.ArrayS(1) As String
   Dim Max.Lines As Long
   Dim Max.File As Long
   Max.Row = 25

   StatusLine1 = 0#
   StatusLine2 = 0#
   StatusLineFileSize# = 0#
   Call Edit.Status.Line

   Filename$ = OutX$
   If Left$(Filename$, 1) = Chr$(34) Then
      Filename$ = Mid$(Filename$, 2)
      If Right$(Filename$, 1) = Chr$(34) Then
         Filename$ = Left$(Filename$, Len(Filename) - 1)
      End If
   End If
   File5 = FreeFile
   Close #File5
   ControlBreak = 0
   If _FileExists(Filename$) Then
      Open Filename$ For Binary As #File5 ' read file in binary
      Max.Lines = 0
      Var& = 0&
      LineX = Nul
      VarD = False
      VarE = False
      VarF! = Timer
      If ForceLINUX Then
         LinuxLoad = -1
      Else
         Print "Edit file in Linux binary read mode(y/n)? ";
         Do
            _Limit 50
            X$ = InKey$
            If LCase$(X$) = "y" Then Print: LinuxLoad = -1: Exit Do
            If LCase$(X$) = "n" Then Print: LinuxLoad = 0: Exit Do
         Loop
      End If
      Percent.Flag = False
      Current.Progress = False
      Do
         Call Dot.Display(VarD, VarE, VarF!)
         StatusLine1 = CDbl(Var&)
         StatusLine2 = LOF(File5)
         StatusLineFileSize = StatusLine2
         Var& = Var& + 1&
         If Var& > LOF(File5) Then
            If Len(LineX) Then
               If Max.Lines >= MaxLong Then
                  Print "Out of memory."
                  Close #File5
                  Erase Temp.ArrayS
                  Exit Sub
               End If
               Max.Lines = Max.Lines + 1
               ReDim _Preserve Temp.ArrayS(Max.Lines) As String
               Temp.ArrayS(Max.Lines) = LineX
            End If
            Exit Do
         End If
         Get #File5, Var&, VarX
         If ControlBreak Then
            ControlBreak = False
            Print "Program load halted."
            Close #File5
            Erase Temp.ArrayS
            Exit Sub
         End If
         LineFeed = 0
         If LinuxLoad Then
            If VarX = Chr$(10) Then
               LineFeed = -1
            End If
         End If
         If VarX = Chr$(13) Then
            If Var& + 1& <= LOF(File5) Then
               Get #File5, Var& + 1&, VarY
               If VarY = Chr$(10) Then
                  Var& = Var& + 1&
                  LineFeed = -1
               End If
            End If
         End If
         If LineFeed Then
            If Max.Lines >= MaxLong Then
               Print "Out of memory."
               Close #File5
               Erase Temp.ArrayS
               Exit Sub
            End If
            Max.Lines = Max.Lines + 1
            ReDim _Preserve Temp.ArrayS(Max.Lines) As String
            Temp.ArrayS(Max.Lines) = LineX
            LineX = Nul
         Else
            LineX = LineX + VarX
         End If
      Loop
      Close #File5
      Max.File = Max.Lines
   End If
   Print
   StatusLine1 = 0#
   StatusLine2 = 0#
   If Max.Lines = 0 Then
      Max.File = 1
      Max.Lines = 1
      Line.Number = 1
      ReDim Temp.ArrayS(Max.Lines) As String
   End If
   Xcoor = 1
   Ycoor = 1
   Column = 1
   Row = 1
   Line.Number = 1
   Line.Length = 78
   GoSub Display.Screen
   Do
      V = Column + Ycoor - 1
      Var# = CDbl(Line.Number)
      If Var# = 0# Then
         Var$ = " 0"
      Else
         Call Amount(Var#, Var$)
      End If
      If V = 0 Then
         Var2$ = " 0"
      Else
         Call Amount(CDbl(V), Var2$)
      End If
      Strng$ = "Row" + Var$ + " Column" + Var2$

      If V > 0 And V <= Len(Temp.ArrayS(Line.Number)) Then
         V2 = Asc(Mid$(Temp.ArrayS(Line.Number), V, 1))
         Strng$ = Strng$ + " Ascii" + Str$(V2)

         Select Case V2
            Case 0
               Strng$ = Strng$ + " (nul)"
            Case 1
               Strng$ = Strng$ + " (soh)"
            Case 2
               Strng$ = Strng$ + " (stx)"
            Case 3
               Strng$ = Strng$ + " (etx)"
            Case 4
               Strng$ = Strng$ + " (eot)"
            Case 5
               Strng$ = Strng$ + " (enq)"
            Case 6
               Strng$ = Strng$ + " (ack)"
            Case 7
               Strng$ = Strng$ + " (bel)"
            Case 8
               Strng$ = Strng$ + " (bs)"
            Case 9
               Strng$ = Strng$ + " (tab)"
            Case 10
               Strng$ = Strng$ + " (lf)"
            Case 11
               Strng$ = Strng$ + " (vt)"
            Case 12
               Strng$ = Strng$ + " (np)"
            Case 13
               Strng$ = Strng$ + " (cr)"
            Case 14
               Strng$ = Strng$ + " (so)"
            Case 15
               Strng$ = Strng$ + " (si)"
            Case 16
               Strng$ = Strng$ + " (dle)"
            Case 17
               Strng$ = Strng$ + " (dc1)"
            Case 18
               Strng$ = Strng$ + " (dc2)"
            Case 19
               Strng$ = Strng$ + " (dc3)"
            Case 20
               Strng$ = Strng$ + " (dc4)"
            Case 21
               Strng$ = Strng$ + " (nak)"
            Case 22
               Strng$ = Strng$ + " (syn)"
            Case 23
               Strng$ = Strng$ + " (etb)"
            Case 24
               Strng$ = Strng$ + " (can)"
            Case 25
               Strng$ = Strng$ + " (em)"
            Case 26
               Strng$ = Strng$ + " (eof)"
            Case 27
               Strng$ = Strng$ + " (esc)"
            Case 28
               Strng$ = Strng$ + " (fs)"
            Case 29
               Strng$ = Strng$ + " (gs)"
            Case 30
               Strng$ = Strng$ + " (rs)"
            Case 31
               Strng$ = Strng$ + " (us)"
            Case 32
               Strng$ = Strng$ + " (spc)"
            Case 255
               Strng$ = Strng$ + " (?)"
            Case Else
               Strng$ = Strng$ + " (" + Chr$(V2) + ")"
         End Select
      End If
      Strng$ = Strng$ + Space$(41 - Len(Strng$))
      Color Yellow, BBlue
      Locate Max.Row - 1, 1
      Print Strng$;
      Locate Xcoor, Ycoor
      Color White, Black
      TempX$ = ""
      Do While TempX$ = ""
         _Limit 50
         TempX$ = InKey$
      Loop
      Select Case Len(TempX$)
         Case 1
            Select Case TempX$
               Case Chr$(18) ' ctrl-r = searchreplace
                  GoSub Replace.String
               Case Chr$(6) ' search string (ctrl-f)
                  If Max.Lines > 0 Then
                     GoSub Search.String
                     If VarX2 Then
                        Line.Number = Count&
                        If Line.Number <= Max.Row - 2 Then
                           Xcoor = Line.Number
                        Else
                           Xcoor = 1
                        End If
                        Ycoor = 1
                        Column = 1
                     End If
                  End If
                  Color White, Black
                  GoSub Display.Screen
               Case Chr$(10) ' jump to byte (ctrl-j)
                  If Max.Lines > 0 Then
                     GoSub Jump.Byte
                     If VarX2 Then
                        Line.Number = Count&
                        If Line.Number <= Max.Row - 2 Then
                           Xcoor = Line.Number
                        Else
                           Xcoor = 1
                        End If
                        Ycoor = 1
                        Column = 1
                     End If
                  End If
                  Color White, Black
                  GoSub Display.Screen
               Case Chr$(7) ' goto to line (ctrl-g)
                  If Max.Lines > 0 Then
                     GoSub Jump.Line
                     If VarX2 Then
                        Line.Number = Count&
                        If Line.Number <= Max.Row - 2 Then
                           Xcoor = Line.Number
                        Else
                           Xcoor = 1
                        End If
                        Ycoor = 1
                        Column = 1
                     End If
                  End If
                  Color White, Black
                  GoSub Display.Screen
               Case Chr$(13) ' insert line
                  ' always increases array
                  If Max.File < MaxLong Then
                     Max.File = Max.File + 1
                     ReDim _Preserve Temp.ArrayS(Max.File) As String
                     ' above
                     If Column + Ycoor - 1 = 1 Then
                        For Temp1 = Max.Lines To Line.Number Step -1
                           Temp.ArrayS(Temp1 + 1) = Temp.ArrayS(Temp1)
                        Next
                        Temp.ArrayS(Line.Number) = Nul
                        Line.Number = Line.Number + 1
                        Max.Lines = Max.Lines + 1
                        If Xcoor < Max.Row - 2 Then
                           Xcoor = Xcoor + 1
                        End If
                     Else
                        ' below
                        If Column + Ycoor - 1 > Len(Temp.ArrayS(Line.Number)) Then
                           Line.Number = Line.Number + 1 ' below
                           For Temp1 = Max.Lines To Line.Number Step -1
                              Temp.ArrayS(Temp1 + 1) = Temp.ArrayS(Temp1)
                           Next
                           Temp.ArrayS(Line.Number) = Nul
                           If Xcoor < Max.Row - 2 Then
                              Xcoor = Xcoor + 1
                           End If
                           Max.Lines = Max.Lines + 1
                        Else
                           ' split line
                           For Temp1 = Max.Lines To Line.Number + 1 Step -1
                              Temp.ArrayS(Temp1 + 1) = Temp.ArrayS(Temp1)
                           Next
                           T$ = Temp.ArrayS(Line.Number)
                           U$ = Mid$(T$, Column + Ycoor - 1)
                           T$ = Left$(T$, Column + Ycoor - 2)
                           Temp.ArrayS(Line.Number) = T$
                           Line.Number = Line.Number + 1 ' below
                           Temp.ArrayS(Line.Number) = U$
                           If Xcoor < Max.Row - 2 Then
                              Xcoor = Xcoor + 1
                           End If
                           Max.Lines = Max.Lines + 1
                        End If
                     End If
                  End If
                  Column = 1
                  Ycoor = 1
                  GoSub Display.Screen
               Case Chr$(8) ' backspace
                  Q = Column + Ycoor - 1
                  If Line.Number <= 1 And Q <= 1 Then ' no backspace at 1,1
                     Eat$ = Nul
                  Else
                     ' remove current line
                     If Temp.ArrayS(Line.Number) = Nul Then
                        ' pack array
                        For Temp1 = Line.Number To Max.Lines - 1
                           Temp.ArrayS(Temp1) = Temp.ArrayS(Temp1 + 1)
                        Next
                        If Xcoor > 1 Then
                           Xcoor = Xcoor - 1
                        End If
                        Line.Number = Line.Number - 1
                        Max.Lines = Max.Lines - 1
                        ' position at eol
                        End.Line = Len(Temp.ArrayS(Line.Number))
                        If End.Line >= 80 Then
                           Column = End.Line - 78
                           Ycoor = End.Line - Column + 2
                        Else
                           Ycoor = End.Line - Column + 2
                        End If
                        GoSub Display.Screen
                     Else
                        ' concatenate previous line
                        If Column + Ycoor - 1 <= 1 Then
                           If Line.Number > 1 Then
                              If Line.Number <= Max.Lines Then
                                 Var = 0
                                 If Temp.ArrayS(Line.Number - 1) = Nul Then
                                    If Ycoor = 1 Then
                                       Var = -1
                                    End If
                                 End If

                                 ' position at eol
                                 If Var = 0 Then
                                    End.Line = Len(Temp.ArrayS(Line.Number - 1))
                                 End If

                                 Temp.ArrayS(Line.Number - 1) = Temp.ArrayS(Line.Number - 1) + Temp.ArrayS(Line.Number)
                                 For Temp1 = Line.Number To Max.Lines - 1
                                    Temp.ArrayS(Temp1) = Temp.ArrayS(Temp1 + 1)
                                 Next
                                 If Xcoor > 1 Then
                                    Xcoor = Xcoor - 1
                                 End If
                                 Line.Number = Line.Number - 1
                                 Max.Lines = Max.Lines - 1
                                 Column = 1
                                 Ycoor = 1

                                 ' position at eol
                                 If Var = 0 Then
                                    If End.Line >= 80 Then
                                       Column = End.Line - 78
                                       Ycoor = End.Line - Column + 2
                                    Else
                                       Ycoor = End.Line - Column + 2
                                    End If
                                 End If

                                 GoSub Display.Screen
                              End If
                           End If
                        Else
                           ' backspace 1 character
                           If Column + Ycoor - 2 > False Then
                              T$ = Temp.ArrayS(Line.Number)
                              T$ = Left$(T$, Column + Ycoor - 3) + Mid$(T$, Column + Ycoor - 1)
                              Temp.ArrayS(Line.Number) = T$
                              StatusLineFileSize = StatusLineFileSize - 1
                              ' move cursor 1 left
                              If Ycoor > 1 Then
                                 Ycoor = Ycoor - 1
                                 GoSub Display.Screen
                              Else
                                 If Column > 1 Then
                                    Column = Column - 1
                                    GoSub Display.Screen
                                 End If
                              End If
                           End If
                        End If
                     End If
                  End If
               Case Chr$(9) ' tab
                  If Column + Ycoor + 7 <= Len(Temp.ArrayS(Line.Number)) Then
                     If Ycoor + 8 < 80 Then
                        Ycoor = Ycoor + 8
                     Else
                        Column = Column + 8
                        GoSub Display.Screen
                     End If
                  Else ' end
                     End.Line = Len(Temp.ArrayS(Line.Number))
                     If End.Line >= 80 Then
                        Column = End.Line - 78
                        Ycoor = End.Line - Column + 2
                        GoSub Display.Screen
                     Else
                        Ycoor = End.Line - Column + 2
                     End If
                  End If
               Case Chr$(27) ' escape, exit editor
                  Exit Do
               Case Else ' insert character
                  If Line.Number > 0 Then
                     T$ = Temp.ArrayS(Line.Number)
                     T$ = Left$(T$, Column + Ycoor - 2) + TempX$ + Mid$(T$, Column + Ycoor - 1)
                     Temp.ArrayS(Line.Number) = T$
                     StatusLineFileSize = StatusLineFileSize + 1
                     If Column + Ycoor - 1 <= Len(Temp.ArrayS(Line.Number)) Then
                        If Ycoor < 80 Then
                           Ycoor = Ycoor + 1
                           GoSub Display.Screen
                        Else
                           Column = Column + 1
                           GoSub Display.Screen
                        End If
                     End If
                  End If
            End Select
         Case 2
            Temp = Asc(Mid$(TempX$, 2, 1))
            Select Case Temp
               Case 96 ' Ctrl-F3 - repeat replace
                  If Search$ = Nul Then
                     GoSub Replace.String
                  Else
                     GoSub Replace.String2
                  End If
               Case 61 ' F3 - continue search
                  If Max.Lines > 0 Then
                     If LastSearchLine& = 0& Then ' init search
                        GoSub Search.String
                     Else
                        GoSub Search.String2
                     End If
                     If VarX2 Then
                        Line.Number = Count&
                        If Line.Number <= Max.Row - 2 Then
                           Xcoor = Line.Number
                        Else
                           Xcoor = 1
                        End If
                        Ycoor = 1
                        Column = 1
                     End If
                  End If
                  Color White, Black
                  GoSub Display.Screen
               Case 15 ' shift-tab
                  If Column + Ycoor - 8 > 0 Then
                     If Column + Ycoor - 7 > 1 Then
                        Ycoor = Ycoor - 7
                     Else
                        If Column > 8 Then
                           Column = Column - 7
                           GoSub Display.Screen
                        End If
                     End If
                  Else ' home
                     If Column > 1 Then
                        Column = 1
                        Ycoor = 1
                        GoSub Display.Screen
                     Else
                        Column = 1
                        Ycoor = 1
                     End If
                  End If
               Case 83, 147 ' delete/control-delete
                  Q = Column + Ycoor - 1
                  ' no delete at 1,1
                  If (Line.Number <= 1 And Q < 1) Or Max.Lines < 1 Then
                     Eat$ = Nul
                  Else
                     ' remove line
                     If Temp.ArrayS(Line.Number) = Nul Then
                        If Line.Number = 1 And Max.Lines = 1 Then ' 1,1
                           Eat$ = Nul
                        Else
                           ' pack array
                           For Temp1 = Line.Number To Max.Lines - 1
                              Temp.ArrayS(Temp1) = Temp.ArrayS(Temp1 + 1)
                           Next
                           If Line.Number = Max.Lines Then
                              Line.Number = Line.Number - 1
                              If Xcoor > 1 Then
                                 Xcoor = Xcoor - 1
                              End If
                           End If
                           Max.Lines = Max.Lines - 1
                           Column = 1
                           Ycoor = 1
                           GoSub Display.Screen
                        End If
                     Else
                        ' delete line
                        If Len(Temp.ArrayS(Line.Number)) < 1 Then
                           Temp.ArrayS(Line.Number) = Nul
                           GoSub Display.Screen
                        Else
                           ' concatenate line
                           If Column + Ycoor - 1 > Len(Temp.ArrayS(Line.Number)) Then
                              If Line.Number + 1 <= Max.Lines Then
                                 T$ = Temp.ArrayS(Line.Number)
                                 T$ = T$ + Temp.ArrayS(Line.Number + 1)
                                 Temp.ArrayS(Line.Number) = T$

                                 ' pack array
                                 For Temp1 = Line.Number + 1 To Max.Lines - 1
                                    Temp.ArrayS(Temp1) = Temp.ArrayS(Temp1 + 1)
                                 Next
                                 Max.Lines = Max.Lines - 1
                                 GoSub Display.Screen
                              End If
                           Else
                              ' delete character
                              T$ = Temp.ArrayS(Line.Number)
                              T$ = Left$(T$, Column + Ycoor - 2) + Mid$(T$, Column + Ycoor)
                              Temp.ArrayS(Line.Number) = T$
                              StatusLineFileSize = StatusLineFileSize - 1
                              GoSub Display.Screen
                           End If
                        End If
                     End If
                  End If
               Case 71 ' home
                  If Column > 1 Then
                     Column = 1
                     Ycoor = 1
                     GoSub Display.Screen
                  Else
                     Column = 1
                     Ycoor = 1
                  End If
               Case 79 ' end
                  End.Line = Len(Temp.ArrayS(Line.Number))
                  If End.Line >= 80 Then
                     Column = End.Line - 78
                     Ycoor = End.Line - Column + 2
                     GoSub Display.Screen
                  Else
                     Ycoor = End.Line - Column + 2
                  End If
               Case 75, 155 ' left/alt-left
                  If Ycoor > 1 Then
                     Ycoor = Ycoor - 1
                  Else
                     If Column > 1 Then
                        Column = Column - 1
                        GoSub Display.Screen
                     End If
                  End If
               Case 77, 157 ' right/alt-right
                  If Column + Ycoor - 1 <= Len(Temp.ArrayS(Line.Number)) Then
                     If Ycoor < 80 Then
                        Ycoor = Ycoor + 1
                     Else
                        Column = Column + 1
                        GoSub Display.Screen
                     End If
                  End If
               Case 72, 141, 152 ' up/ctrl-up/alt-up
                  Var = 0
                  If Line.Number > 1 Then
                     Line.Number = Line.Number - 1
                     If Xcoor = 1 Then
                        Var = -1
                     Else
                        Xcoor = Xcoor - 1
                     End If
                     End.Line = Len(Temp.ArrayS(Line.Number)) + 1
                     If Column + Ycoor - 1 > End.Line Then
                        Ycoor = End.Line - Column + 1
                        If Ycoor <= 0 Then
                           Ycoor = End.Line
                           If Column > 1 Then
                              Var = -1
                           End If
                           Column = 1
                        End If
                     End If
                     If Var Then
                        GoSub Display.Screen
                     End If
                  End If
               Case 80, 145, 160 ' down/ctrl-dn/alt-dn
                  Var = 0
                  If Line.Number < Max.Lines Then
                     Line.Number = Line.Number + 1
                     If Xcoor >= Max.Row - 2 Then
                        Var = -1
                     Else
                        Xcoor = Xcoor + 1
                     End If
                     End.Line = Len(Temp.ArrayS(Line.Number)) + 1
                     If Column + Ycoor - 1 > End.Line Then
                        Ycoor = End.Line - Column + 1
                        If Ycoor <= 0 Then
                           Ycoor = End.Line
                           If Column > 1 Then
                              Var = -1
                           End If
                           Column = 1
                        End If
                     End If
                     If Var Then
                        GoSub Display.Screen
                     End If
                  End If
               Case 73, 132 ' pageup/ctrl-pageup
                  If Line.Number > 1 Then
                     If Line.Number - 22 > 1 Then
                        Line.Number = Line.Number - 22
                     Else
                        Line.Number = 1
                     End If
                     Xcoor = 1
                     End.Line = Len(Temp.ArrayS(Line.Number)) + 1
                     If Column + Ycoor - 1 > End.Line Then
                        Ycoor = End.Line - Column + 1
                        If Ycoor <= 0 Then
                           Ycoor = End.Line
                           If Column > 1 Then
                              Var = -1
                           End If
                           Column = 1
                        End If
                     End If
                     GoSub Display.Screen
                  End If
               Case 81, 118 ' pagedown/ctrl-pagedn
                  If Line.Number < Max.Lines Then
                     If Line.Number + 22 < Max.Lines Then
                        Line.Number = Line.Number + 22
                        Xcoor = 1
                     Else
                        Line.Number = Max.Lines
                        If Max.Lines < Max.Row - 3 Then
                           Xcoor = Max.Lines
                        Else
                           Xcoor = Max.Row - 3
                        End If
                     End If
                     End.Line = Len(Temp.ArrayS(Line.Number)) + 1
                     If Column + Ycoor - 1 > End.Line Then
                        Ycoor = End.Line - Column + 1
                        If Ycoor <= 0 Then
                           Ycoor = End.Line
                           If Column > 1 Then
                              Var = -1
                           End If
                           Column = 1
                        End If
                     End If
                     GoSub Display.Screen
                  End If
               Case 116 ' control-right
                  If Column + Ycoor - 1 > Len(Temp.ArrayS(Line.Number)) Then ' eol
                     If Line.Number + 1 <= Max.Lines Then
                        Line.Number = Line.Number + 1
                        If Xcoor = Max.Row - 3 Then
                           Var = True
                        Else
                           Xcoor = Xcoor + 1
                        End If
                        Ycoor = 1
                        Column = 1
                        GoSub Display.Screen
                     End If
                  Else
                     P = 0
                     For Temp2 = Column + Ycoor - 1 To Len(Temp.ArrayS(Line.Number))
                        P = P + 1
                        If Mid$(Temp.ArrayS(Line.Number), Temp2, 1) = " " Then
                           If Mid$(Temp.ArrayS(Line.Number), Temp2 + 1, 1) <> " " Then
                              Exit For
                           End If
                        End If
                     Next
                     'shift right
                     For Var3 = 1 To P
                        If Ycoor < 80 Then
                           Ycoor = Ycoor + 1
                        Else
                           Column = Column + 1
                        End If
                     Next
                     GoSub Display.Screen
                  End If
               Case 115 ' control-left
                  If Column + Ycoor - 1 <= 1 Then
                     If Line.Number > 1 Then
                        Line.Number = Line.Number - 1
                        If Xcoor = 1 Then
                           Var = True
                        Else
                           Xcoor = Xcoor - 1
                        End If
                        End.Line = Len(Temp.ArrayS(Line.Number))
                        If End.Line >= 80 Then
                           Column = End.Line - 78
                           Ycoor = End.Line - Column + 2
                        Else
                           Ycoor = End.Line - Column + 2
                        End If
                        GoSub Display.Screen
                     End If
                  Else
                     P = 0
                     V = 0
                     For Temp2 = Column + Ycoor - 3 To 1 Step -1
                        P = P + 1
                        If Mid$(Temp.ArrayS(Line.Number), Temp2, 1) = " " Then
                           If Mid$(Temp.ArrayS(Line.Number), Temp2 + 1, 1) <> " " Then
                              V = -1
                              Exit For
                           End If
                        End If
                     Next
                     If V = 0 Then
                        P = P + 1
                     End If
                     ' shift left
                     For Var3 = 1 To P
                        If Ycoor > 1 Then
                           Ycoor = Ycoor - 1
                        Else
                           If Column > 1 Then
                              Column = Column - 1
                           End If
                        End If
                     Next
                     GoSub Display.Screen
                  End If
               Case 119 ' control-home
                  If Max.Lines > 0 Then
                     Line.Number = 1
                     Xcoor = 1
                     Ycoor = 1
                     Column = 1
                     GoSub Display.Screen
                  End If
               Case 117 ' control-end
                  If Max.Lines > 0 Then
                     Line.Number = Max.Lines
                     If Max.Lines < Max.Row - 3 Then
                        Xcoor = Max.Lines
                     Else
                        Xcoor = Max.Row - 3
                     End If
                     Ycoor = 1
                     Column = 1
                     GoSub Display.Screen
                  End If
               Case 82 ' insert
                  If Line.Number > 0 Then
                     Var = False
                     Ascii$ = Nul
                     GoSub Display.Ascii.Line
                     Do
                        Var$ = Nul
                        Do
                           _Limit 50
                           Var$ = InKey$
                           If Len(Var$) Then
                              Exit Do
                           End If
                        Loop
                        If Len(Var$) = 1 Then
                           If Var$ = Chr$(8) Then
                              If Len(Ascii$) > 0 Then
                                 Ascii$ = Left$(Ascii$, Len(Ascii$) - 1)
                                 GoSub Display.Ascii.Line
                                 Var = Var - 1
                                 Locate Max.Row - 1, 27
                                 Print Ascii$ + " ";
                                 Locate Max.Row - 1, 27
                                 Print Ascii$;
                              End If
                           End If
                           If Var$ = Chr$(13) Then
                              Exit Do
                           End If
                           If LCase$(Var$) = "x" Or LCase$(Var$) = "o" Or LCase$(Var$) = "b" Then
                              If Var = 0 Then
                                 Ascii$ = Ascii$ + LCase$(Var$)
                                 GoSub Display.Ascii.Line
                                 Var = Var + 1
                                 Locate Max.Row - 1, 26 + Var
                                 Strng$ = LCase$(Var$)
                                 Print Strng$;
                              End If
                           End If
                           If LCase$(Var$) >= "a" And LCase$(Var$) <= "f" Then
                              If Var >= 1 And Var < 3 Then
                                 If Left$(Ascii$, 1) = "x" Then
                                    Var = Var + 1
                                    Locate Max.Row - 1, 26 + Var
                                    Strng$ = Var$
                                    Print Strng$;
                                    Ascii$ = Ascii$ + Var$
                                 End If
                              End If
                           End If
                           If Left$(Ascii$, 1) = "o" Then
                              If Var$ >= "0" And Var$ <= "7" Then
                                 If Var < 4 Then
                                    Var = Var + 1
                                    Locate Max.Row - 1, 26 + Var
                                    Strng$ = Var$
                                    Print Strng$;
                                    Ascii$ = Ascii$ + Var$
                                 End If
                              End If
                           Else
                              If Left$(Ascii$, 1) = "b" Then
                                 If Var$ = "0" Or Var$ = "1" Then
                                    If Var < 9 Then
                                       Var = Var + 1
                                       Locate Max.Row - 1, 26 + Var
                                       Strng$ = Var$
                                       Print Strng$;
                                       Ascii$ = Ascii$ + Var$
                                    End If
                                 End If
                              Else
                                 If Var$ >= "0" And Var$ <= "9" Then
                                    If Var < 3 Then
                                       Var = Var + 1
                                       Locate Max.Row - 1, 26 + Var
                                       Print Var$;
                                       Ascii$ = Ascii$ + Var$
                                    End If
                                 End If
                              End If
                           End If
                        End If
                     Loop
                     Color White, Black

                     ' insert ascii character
                     If Left$(Ascii$, 1) = "x" Then
                        Ascii.Value = Int(Val("&H" + Mid$(Ascii$, 2)))
                     Else
                        If Left$(Ascii$, 1) = "o" Then
                           Ascii.Value = Int(Val("&O" + Mid$(Ascii$, 2)))
                        Else
                           If Left$(Ascii$, 1) = "b" Then ' binary
                              Ascii$ = Mid$(Ascii$, 2)
                              GoSub Binary.String
                           Else
                              Ascii.Value = Int(Val(Ascii$))
                           End If
                        End If
                     End If
                     If Ascii.Value >= 0 And Ascii.Value <= 255 Then
                        TempX$ = Chr$(Ascii.Value)
                        T$ = Temp.ArrayS(Line.Number)
                        T$ = Left$(T$, Column + Ycoor - 2) + TempX$ + Mid$(T$, Column + Ycoor - 1)
                        Temp.ArrayS(Line.Number) = T$
                        StatusLineFileSize = StatusLineFileSize + 1
                        If Column + Ycoor - 1 <= Len(Temp.ArrayS(Line.Number)) Then
                           If Ycoor < 80 Then
                              Ycoor = Ycoor + 1
                              GoSub Display.Screen
                           Else
                              Column = Column + 1
                              GoSub Display.Screen
                           End If
                        End If
                     End If
                  End If
            End Select
      End Select
   Loop
   Color White, Black
   Cls
   Call Edit.Status.Line
   Locate Max.Row - 1, 1
   Q = 0
   Print "Write "; Filename$; " to disk(y/n)? ";
   Do
      _Limit 50
      Char$ = InKey$
      Char$ = UCase$(Char$)
      If Char$ = "Y" Then
         Q = -1
         Print "y"
         Exit Do
      End If
      If Char$ = "N" Then
         Print "n"
         Exit Do
      End If
   Loop
   If Q Then
      Close #File5
      If _FileExists(Filename$) Then
         f$ = Filename$ + Chr$(0)
         x = DeleteFileA%(f$)
      End If
      If ForceLINUX Then
         LinuxSave = -1
      Else
         Print "Save file in Linux binary write mode(y/n)? ";
         Do
            _Limit 50
            X$ = InKey$
            If LCase$(X$) = "y" Then Print: LinuxSave = -1: Exit Do
            If LCase$(X$) = "n" Then Print: LinuxSave = 0: Exit Do
         Loop
      End If
      TotalBytes2# = 0#
      For Count& = 1& To Max.Lines
         TotalBytes2# = TotalBytes2# + Len(RTrim$(Temp.ArrayS(Count&)))
      Next
      VarD = False
      VarE = False
      VarF! = Timer
      StatusLine1 = 0#
      StatusLine2 = TotalBytes2#
      If LinuxSave Then
         Open Filename$ For Binary As #File5
         Var& = 0&
         Percent.Flag = False
         Current.Progress = False
         For Count& = 1& To Max.Lines
            For Count2 = 1 To Len(Temp.ArrayS(Count&))
               VarX = Mid$(Temp.ArrayS(Count&), Count2, 1)
               Var& = Var& + 1&
               Put File5, Var&, VarX
               StatusLine1 = CDbl(Var&)
               Call Dot.Display(VarD, VarE, VarF!)
            Next
            Var& = Var& + 1&
            VarX = Chr$(10)
            Put File5, Var&, VarX
         Next
      Else
         Var& = 0&
         _ControlChr Off
         Open Filename$ For Output As #File5
         For Count& = 1& To Max.Lines
            Var& = Var& + Len(RTrim$(Temp.ArrayS(Count&)))
            StatusLine1 = CDbl(Var&)
            Print #File5, Temp.ArrayS(Count&)
         Next
         _ControlChr On
      End If
      Close #File5
      If LinuxSave Then
         Print Str$(Var&) + " binary bytes stored to disk."
      Else
         Print Str$(Var&) + " bytes stored to disk."
      End If
      Call MorePrompt(MorePrompt4, "y " + Chr$(13), Output.Char$)
   End If
   Erase Temp.ArrayS
   Exit Sub

   Display.Ascii.Line:
   Color White, BBlue
   Locate Max.Row - 1, 1, 1
   Color White, BBlue
   Strng$ = Space$(41)
   Print Strng$;
   Locate Max.Row - 1, 1, 1
   If Left$(Ascii$, 1) = "x" Then
      Var2$ = "Enter 2-digit ascii code: "
   Else
      If Left$(Ascii$, 1) = "o" Then
         Var2$ = "Enter 3-digit ascii code: "
      Else
         If Left$(Ascii$, 1) = "b" Then
            Var2$ = "Enter 8-digit ascii code: "
         Else
            Var2$ = "Enter 3-digit ascii code: "
         End If
      End If
   End If
   VarC = Len(Var2$) + Len(Ascii$)
   Var2$ = Var2$ + Space$(41 - Len(Var2$))
   Print Var2$;
   Locate Max.Row - 1, VarC, 1
   Return

   Binary.String:
   Ascii.Value = False
   Binary.Power = False
   For Binary.Digit = Len(Ascii$) To 1 Step -1
      OutX2$ = Mid$(Ascii$, Binary.Digit, 1)
      Select Case OutX2$
         Case "0"
            ' nul
         Case "1"
            Ascii.Value = Ascii.Value + 2 ^ Binary.Power
      End Select
      Binary.Power = Binary.Power + 1
   Next
   Return

   Jump.Line:
   Color White, BBlue
   Locate Max.Row - 1, 1
   Strng$ = Space$(80)
   Print Strng$;
   Color Yellow, BBlue
   Locate Max.Row - 1, 1
   prompt$ = "Enter line number(1-" + LTrim$(Str$(Max.Lines)) + ")? "
   X$ = KeyboardLine3$(prompt$)

   VarX2 = -1
   If Len(X$) = 0 Then
      VarX2 = 0
   Else
      If Len(X$) > 7 Then
         VarX2 = 0
      Else
         VarX2 = IsNumeric(X$)
      End If
   End If
   Count& = 0&
   If VarX2 Then
      If Val(X$) > 0 And Val(X$) <= Max.Lines Then
         Count& = Val(X$)
      Else
         VarX2 = 0
      End If
   End If
   Return

   Jump.Byte:
   ' count bytes in edit array
   x# = 0#
   For X& = 1 To Max.Lines
      x# = x# + Len(Temp.ArrayS(X&))
   Next

   Color White, BBlue
   Locate Max.Row - 1, 1
   Strng$ = Space$(80)
   Print Strng$;
   Color Yellow, BBlue
   Locate Max.Row - 1, 1
   prompt$ = "Enter byte number(1-" + LTrim$(Str$(x#)) + ")? "
   X$ = KeyboardLine3$(prompt$)

   VarX2 = -1
   If Len(X$) = 0 Then
      VarX2 = 0
   Else
      If Len(X$) > 15 Then
         VarX2 = 0
      Else
         VarX2 = IsNumeric(X$)
      End If
   End If
   T# = 0#
   If VarX2 Then
      Count# = Val(X$)
      If Count# > 0 And Count# <= x# Then
         For Count& = 1 To Max.Lines
            If T# + Len(Temp.ArrayS(Count&)) >= Count# Then
               Exit For
            End If
            T# = T# + Len(Temp.ArrayS(Count&))
         Next
      Else
         VarX2 = 0
      End If
   End If
   Return

   Replace.String:
   If Max.Lines > 0 Then
      Color White, BBlue
      Locate Max.Row - 1, 1
      Strng$ = Space$(80)
      Print Strng$;
      Color Yellow, BBlue
      Locate Max.Row - 1, 1
      Line Input ; "Enter search string? "; Search$

      Color White, BBlue
      Locate Max.Row - 1, 1
      Strng$ = Space$(80)
      Print Strng$;
      Color Yellow, BBlue
      Locate Max.Row - 1, 1
      Line Input ; "Enter replace string? "; Replace$

      Replace.String2:

      Color White, BBlue
      Locate Max.Row - 1, 1
      Strng$ = Space$(80)
      Print Strng$;
      Color Yellow, BBlue
      Locate Max.Row - 1, 1
      Print "Enter (R)eplace, Replace(A)ll, (C)ancel? ";
      Do
         _Limit 50
         X$ = InKey$
         x = 0
         If UCase$(X$) = "R" Then x = 1: Exit Do
         If UCase$(X$) = "A" Then x = 2: Exit Do
         If UCase$(X$) = "C" Then x = 0: Exit Do
      Loop
      If x Then
         Color White, BBlue
         Locate Max.Row - 1, 1
         Strng$ = Space$(80)
         Print Strng$;
         Color Yellow, BBlue
         Locate Max.Row - 1, 1
         Print "Case-sensitive(y/n)? ";
         Do
            _Limit 50
            Y$ = InKey$
            If UCase$(Y$) = "Y" Then SensitiveSelect = -1: Exit Do
            If UCase$(Y$) = "N" Then SensitiveSelect = 0: Exit Do
         Loop
      End If

      If x = 1 Then ' replace
         ' store current screen
         Store1 = Xcoor
         Store2 = Ycoor
         Store3 = Column
         Store& = Line.Number
         ' start replace
         Count& = 0&
         If Len(Search$) Then
            For X& = Store& To Max.Lines
               S1 = 1
               Text$ = Temp.ArrayS(X&)
               Do
                  If SensitiveSelect Then
                     P1 = InStr(S1, Text$, Search$)
                  Else
                     P1 = InStr(S1, UCase$(Text$), UCase$(Search$))
                  End If
                  If P1 Then
                     ' jump to line
                     Ycoor = 1
                     Column = 1
                     Line.Number = X&
                     If Line.Number <= 23 Then
                        Xcoor = Line.Number
                     Else
                        Xcoor = 1
                     End If
                     ' display screen
                     Color White, Black
                     GoSub Display.Screen

                     ' display text to replace
                     If P1 + Len(Search$) < 80 Then
                        If Len(Search$) < 80 Then
                           Locate Xcoor, P1
                           Color Scolor, Scolor2
                           Var1$ = Mid$(Text$, P1, Len(Search$))
                           _ControlChr Off
                           Print Var1$;
                           _ControlChr On
                           Color White, Black
                        End If
                     Else
                        If Len(Search$) < 80 Then
                           ' move right until search fits
                           Do
                              If Column + Ycoor + 1 < P1 + Len(Search) Then
                                 If Ycoor < 80 Then
                                    Ycoor = Ycoor + 1
                                 Else
                                    Column = Column + 1
                                 End If
                              Else
                                 Exit Do
                              End If
                           Loop
                           ' decrease until display search fits in line
                           Do Until Ycoor + Len(Search$) < 80
                              Ycoor = Ycoor - 1
                           Loop
                           ' check display search at end of line
                           If Ycoor + Len(Search$) <= 80 Then
                              GoSub Display.Screen
                              Locate Xcoor, Ycoor, 1
                              Color Scolor, Scolor2
                              Var1$ = Mid$(Text$, P1, Len(Search$))
                              _ControlChr Off
                              Print Var1$;
                              _ControlChr On
                              Color White, Black
                           End If
                        End If
                     End If

                     ' z=-1 replace, z=1 skip, z=0 cancel
                     Color White, BBlue
                     Locate Max.Row - 1, 1
                     Strng$ = Space$(80)
                     Print Strng$;
                     Color Yellow, BBlue
                     Locate Max.Row - 1, 1
                     Print "Enter (R)eplace, (S)kip, (C)ancel? ";
                     Do
                        _Limit 50
                        X$ = InKey$
                        z = 0
                        If UCase$(X$) = "R" Then z = -1: Exit Do
                        If UCase$(X$) = "S" Then z = 1: Exit Do
                        If UCase$(X$) = "C" Then z = 0: Exit Do
                     Loop
                     If z = 0 Then ' cancel
                        Exit For
                     End If
                     If z = -1 Then ' replace
                        Text$ = Left$(Text$, P1 - 1) + Replace$ + Mid$(Text$, P1 + Len(Search$))
                        Temp.ArrayS(X&) = Text$
                        Count& = Count& + 1&
                        StatusLineFileSize = StatusLineFileSize - Len(Search$) + Len(Replace$)
                     End If
                  Else
                     Exit Do
                  End If
                  S1 = P1 + Len(Replace$)
               Loop
            Next
         End If
         ' restore current screen
         Color White, Black
         GoSub Display.Screen

         Xcoor = Store1
         Ycoor = Store2
         Column = Store3
         Line.Number = Store&

         Color White, BBlue
         Locate Max.Row - 1, 1
         Strng$ = Space$(80)
         Print Strng$;
         Color Yellow, BBlue
         Locate Max.Row - 1, 1
         ' display replacements
         If Count& = 0& Then
            Print "Text not found. Press any key.";
         Else
            Print "Replaced" + Str$(Count&) + " strings. Press any key.";
         End If
         While InKey$ = ""
            _Limit 50
         Wend
         Color White, Black
         GoSub Display.Screen
      End If
      If x = 2 Then ' replaceall
         Count& = 0&
         If Len(Search$) Then
            For X& = 1& To Max.Lines
               Text$ = Temp.ArrayS(X&)
               Flag = 0
               S1 = 1
               Do
                  If SensitiveSelect Then
                     P1 = InStr(S1, Text$, Search$)
                  Else
                     P1 = InStr(S1, UCase$(Text$), UCase$(Search$))
                  End If
                  If P1 Then
                     Flag = -1
                     Text$ = Left$(Text$, P1 - 1) + Replace$ + Mid$(Text$, P1 + Len(Search$))
                     Count& = Count& + 1&
                     StatusLineFileSize = StatusLineFileSize - Len(Search$) + Len(Replace$)
                  Else
                     Exit Do
                  End If
                  S1 = P1 + Len(Replace$)
               Loop
               If Flag Then
                  Temp.ArrayS(X&) = Text$
               End If
            Next
         End If
         Color White, Black
         GoSub Display.Screen
         Color White, BBlue
         Locate Max.Row - 1, 1
         Strng$ = Space$(80)
         Print Strng$;
         Color Yellow, BBlue
         Locate Max.Row - 1, 1
         ' display replacements
         If Count& = 0& Then
            Print "Text not found. Press any key.";
         Else
            Print "Replaced" + Str$(Count&) + " strings. Press any key.";
         End If
         While InKey$ = ""
            _Limit 50
         Wend
         Color White, Black
         GoSub Display.Screen
      End If
   End If
   Return

   ' init search
   Search.String:

   Color White, BBlue
   Locate Max.Row - 1, 1
   Strng$ = Space$(80)
   Print Strng$;
   Color Yellow, BBlue
   Locate Max.Row - 1, 1
   Line Input ; "Enter search string? "; X$

   Color White, BBlue
   Locate Max.Row - 1, 1
   Strng$ = Space$(80)
   Print Strng$;
   Color Yellow, BBlue
   Locate Max.Row - 1, 1
   Line Input ; "Case-sensitive(y/n)? "; Y$
   If UCase$(Y$) = "Y" Then CaseSensitive = -1
   If UCase$(Y$) = "N" Then CaseSensitive = 0

   Color White, BBlue
   Locate Max.Row - 1, 1
   Strng$ = Space$(80)
   Print Strng$;
   Color Yellow, BBlue
   Locate Max.Row - 1, 1
   Line Input ; "Use wildcards(y/n)? "; Z$
   If UCase$(Z$) = "Y" Then WildCards = -1
   If UCase$(Z$) = "N" Then WildCards = 0

   LastSearchLine& = 0&
   LastSearchString$ = X$
   VarX2 = 0
   If Len(X$) = 0 Then
      Return
   End If
   For Count& = 1 To Max.Lines
      If WildCards Then
         VarX1$ = Temp.ArrayS(Count&)
         VarX2$ = X$
         Call InstrSUB1(VarX2, VarX2$, VarX1$, CaseSensitive)
         If VarX2 Then
            LastSearchLine& = Count&
            Exit For
         End If
      Else
         If CaseSensitive Then
            If InStr(Temp.ArrayS(Count&), X$) Then
               LastSearchLine& = Count&
               VarX2 = -1
               Exit For
            End If
         Else
            VarX1$ = UCase$(Temp.ArrayS(Count&))
            VarX2$ = UCase$(X$)
            If InStr(VarX1$, VarX2$) Then
               LastSearchLine& = Count&
               VarX2 = -1
               Exit For
            End If
         End If
      End If
   Next
   Return

   ' continue search
   Search.String2:
   X$ = LastSearchString$
   VarX2 = 0
   If Len(X$) Then
      For Count& = LastSearchLine& + 1& To Max.Lines
         If WildCards Then
            VarX1$ = Temp.ArrayS(Count&)
            VarX2$ = X$
            Call InstrSUB1(VarX2, VarX2$, VarX1$, CaseSensitive)
            If VarX2 Then
               LastSearchLine& = Count&
               Exit For
            End If
         Else
            If CaseSensitive Then
               If InStr(Temp.ArrayS(Count&), X$) Then
                  LastSearchLine& = Count&
                  VarX2 = -1
                  Exit For
               End If
            Else
               VarX1$ = UCase$(Temp.ArrayS(Count&))
               VarX2$ = UCase$(X$)
               If InStr(VarX1$, VarX2$) Then
                  LastSearchLine& = Count&
                  VarX2 = -1
                  Exit For
               End If
            End If
         End If
      Next
   End If
   Return

   ' redisplay editor screen
   Display.Screen:
   Color White, Black
   Cls
   Locate 1, 1
   Count = 0
   Do
      Count = Count + 1
      If Count = Max.Row - 1 Then
         Exit Do
      End If
      If Count + Line.Number - Xcoor > Max.Lines Then
         Exit Do
      End If
      Locate Count, 1
      Strng$ = Mid$(Temp.ArrayS(Count + Line.Number - Xcoor), Column)
      If Len(Strng$) > 80 Then
         Strng$ = Left$(Strng$, 80)
      End If
      _ControlChr Off
      Print Strng$;
      _ControlChr On
   Loop
   If Count < Max.Row - 1 Then
      Locate Count, 1
      Color Red, Black
      Print "<end of file>";
   End If
   Color Yellow, BBlue
   Locate Max.Row - 1, 1
   Print Space$(78);
   Color Black, BBlue
   Locate Max.Row - 1, 79, 0
   Print " ";
   Locate Max.Row - 1, 80, 0
   Print " ";
   Color White, Black
   Call Edit.Status.Line
   Return
End Sub

' display editor title bar
Sub CPUtrap
   S$ = Str$(Int(GetCPULoad * 10000) / 100) ' 100.00
   If InStr(S$, ".") Then
      Q$ = Mid$(S$, InStr(S$, ".") + 1)
      S$ = Left$(S$, InStr(S$, ".") - 1)
      Q$ = Left$(Q$, 3)
      S$ = S$ + "." + Q$
   Else
      S$ = S$ + ".0"
   End If
   D$ = "CPU " + S$ + "%" ' 100.00
   Call Suffix(TotalPhysicalMem, z$) ' 1,024.0 KB
   D$ = D$ + " - Total MEM - " + z$
   _Title "Menu Editor - " + D$
End Sub

' display editor status line
Sub Edit.Status.Line
   TempX$ = "Menu Editor > Time: " + Date$ + " " + Time$ + " "
   If StatusLine1 = 0# And StatusLine2 = 0# Then
      If StatusLineFileSize > 0# Then
         TempX$ = TempX$ + "Size: " + FormatString$(StatusLineFileSize) + " bytes."
      End If
   Else
      TempX$ = TempX$ + FormatString$(StatusLine1) + " of " + FormatString$(StatusLine2)
   End If
   TempX$ = Left$(TempX$, 79)
   TempX$ = TempX$ + Space$(79 - Len(TempX$))
   Call Display.Status.Line(-1, TempX$)
End Sub

' display status line
Sub Display.Status.Line (Var, Var$)
   X = CsrLin
   Y = Pos(0)
   ' Max.Row = PageLength + 2
   Max.Row = 25
   If Var Then
      Color Yellow, BBlue
   Else
      Color White, Black
   End If
   Locate Max.Row, 1, 0
   Print Var$;
   Locate Max.Row, 80
   If Var Then
      Color Black, BBlue
   Else
      Color Plain, Black
   End If
   Print " ";
   Locate Max.Row - 1, 1, 1
   Color White, Black
   Locate X, Y, 1
End Sub

Sub Dot.Display (VarA, VarB, VarC!)
   ' check display timer
   VarG! = Timer - VarC!
   If VarG! >= 1! Then
      VarC! = Timer
      ' default to display dots.
      If DotChar = "" Then
         Exit Sub
      End If
      If VarA = False Then
         VarB = VarB + 1
         Print DotChar;
         If VarB = DotCount Then
            VarA = True
            VarB = False
         End If
      Else
         VarB = VarB + 1
         For VarX = 1 To Len(DotChar)
            Call BackSpace
            Print " ";
            Call BackSpace
         Next
         If VarB = DotCount Then
            VarA = False
            VarB = False
         End If
      End If
   End If
End Sub

Sub BackSpace
   If Pos(0) > 1 Then
      Locate CsrLin, Pos(0) - 1, 0
      Print " ";
      Locate CsrLin, Pos(0) - 1, 1
   End If
End Sub

Sub Make.Format (Var#, Var$)
   Var2# = Var#
   If Var2# <= 0 Then
      Var$ = "0.00 B"
      Exit Sub
   End If
   TempA = False
   Do
      If Var2# < 1024# Then
         Exit Do
      End If
      Var2# = Var2# / 1024#
      TempA = TempA + 1
      If TempA = 8 Then
         Exit Do
      End If
   Loop
   Strng$ = ""
   If TempA >= 1 And TempA <= 8 Then
      Strng$ = Mid$("KMGTPEZY", TempA, 1)
   End If
   Var$ = FormatString$(Var2#) + " " + Strng$ + "B"
End Sub

Sub Amount (Var#, Var$)
   If Var# = 0# Then
      Var$ = " 0"
   Else
      If InStr(Str$(Var#), "D") Then
         Var$ = Str$(Var#)
      Else
         Var$ = " " + FormatString$(Var#)
      End If
   End If
End Sub

' get volume label
Sub Vlabel (Var$)
   If Compatible = 0 Then
      If LINUX Or MACOSX Then
         Var$ = Nul
         Exit Sub
      End If
   End If

   ' get drive info.
   VarX$ = Var$ + ":\" + Chr$(0)
   Var$ = Nul
   Vname$ = Space$(MAX_PATH)
   Fname$ = Space$(MAX_PATH)
   R = GetVolumeInformationA(VarX$, Vname$, MAX_PATH, serial~&, empty1~&, empty2~&, Fname$, MAX_PATH)
   If R Then
      ' get volume label.
      Var$ = RTrim$(Vname$)
      v = InStr(Var$, Chr$(0))
      If v Then Var$ = Left$(Var$, v - 1)
   End If
End Sub

' get volume serial number
Sub Vserial (Var$)
   If Compatible = 0 Then
      If LINUX Or MACOSX Then
         Var$ = Nul
         Exit Sub
      End If
   End If

   ' get drive info.
   VarX$ = Var$ + ":\" + Chr$(0)
   Var$ = Nul
   Vname$ = Space$(MAX_PATH)
   Fname$ = Space$(MAX_PATH)
   R = GetVolumeInformationA(VarX$, Vname$, MAX_PATH, serial~&, empty1~&, empty2~&, Fname$, MAX_PATH)
   If R Then
      ' serial number.
      Var$ = Left$(Hex$(serial~&), 4) + "-" + Right$(Hex$(serial~&), 4)
   End If
End Sub

' get volume system type
Sub Vtype (Var$)
   If Compatible = 0 Then
      If LINUX Or MACOSX Then
         Var$ = Nul
         Exit Sub
      End If
   End If

   ' get drive info.
   VarX$ = Var$ + ":\" + Chr$(0)
   Var$ = Nul
   Vname$ = Space$(MAX_PATH)
   Fname$ = Space$(MAX_PATH)
   R = GetVolumeInformationA(VarX$, Vname$, MAX_PATH, serial~&, empty1~&, empty2~&, Fname$, MAX_PATH)
   If R Then
      ' get volume system type.
      Var$ = RTrim$(Fname$)
      v = InStr(Var$, Chr$(0))
      If v Then Var$ = Left$(Var$, v - 1)
   End If
End Sub

' get drive freespace
Sub FreeSpace (Var$)
   If Compatible = 0 Then
      If LINUX Or MACOSX Then
         Var$ = Nul
         Exit Sub
      End If
   End If

   VarX$ = Var$ + ":\" + Chr$(0)
   Var$ = Nul

   ' check disk exists
   c = Asc(Left$(VarX$, 1)) - 64
   If DRIVEEXISTS(c) Then
      Exit Sub
   End If

   ' always try to read a cd-rom
   '   If DriveType = "[CDROM]" Then
   '      Exit Sub
   '   End If

   ' always try to detect file space during a memory stick
   '   If DriveType = "[REMOVABLE]" Then
   '      Exit Sub
   '   End If
   r = GetDiskFreeSpaceExA(VarX$, free~&&, total~&&, free2~&&)
   If r Then
      Var$ = LTrim$(Str$(free~&&))
   End If
   Exit Sub

   r = GetDiskFreeSpaceA(VarX$, sectors&, bytes&, free&, total&)
   If r Then
      ' sectors per cluster * bytes per sector * free clusters
      x1# = CDbl(sectors&) * CDbl(bytes&) * CDbl(free&)
      Var$ = LTrim$(Str$(x1#))
   End If
End Sub

' get drive totalspace
Sub TotalSpace (Var$)
   If Compatible = 0 Then
      If LINUX Or MACOSX Then
         Var$ = Nul
         Exit Sub
      End If
   End If

   VarX$ = Var$ + ":\" + Chr$(0)
   Var$ = Nul

   ' check disk exists
   c = Asc(Left$(VarX$, 1)) - 64
   If DRIVEEXISTS(c) Then
      Exit Sub
   End If

   ' always try to read a cd-rom
   '   If DriveType = "[CDROM]" Then
   '      Exit Sub
   '   End If

   ' always try to detect file space during a memory stick
   '   If DriveType = "[REMOVABLE]" Then
   '      Exit Sub
   '   End If
   r = GetDiskFreeSpaceExA(VarX$, free~&&, total~&&, free2~&&)
   If r Then
      Var$ = LTrim$(Str$(total~&&))
   End If
   Exit Sub

   r = GetDiskFreeSpaceA(VarX$, sectors&, bytes&, free&, total&)
   If r Then
      ' sectors per cluster * bytes per sector * total clusters
      x1# = CDbl(sectors&) * CDbl(bytes&) * CDbl(total&)
      Var$ = LTrim$(Str$(x1#))
   End If
End Sub

' ambiguate function
Function Ambiguate2$ (Var$)
   VarX$ = Var$
   If InStr(VarX$, ":") Then
      VarX$ = Mid$(VarX$, InStr(VarX$, ":") + 1)
   End If
   For VarX = Len(VarX$) To 1 Step -1
      If Mid$(VarX$, VarX, 1) = "\" Then
         VarX$ = Mid$(VarX$, VarX + 1)
         Exit For
      End If
   Next
   Ambiguate2$ = VarX$
End Function

' ambiguate function
Function Ambiguate$ (Var$)
   Dim ASCIIZ4 As String * 260
   Dim ASCIIZ5 As String * 260

   If Len(Var$) = 0 Then
      Ambiguate$ = Nul
      Exit Function
   End If

   If Compatible = 0 Then
      If LINUX Or MACOSX Then
         Ambiguate$ = Var$
         Exit Function
      End If
   End If

   ASCIIZ4 = Var$ + Chr$(0)
   ret = GetShortPathName(ASCIIZ4, ASCIIZ5, MAX_PATH + 1)
   If ret > 0 Then
      Var2$ = ASCIIZ5
   Else
      Var2$ = ASCIIZ4
   End If
   v = InStr(Var2$, Chr$(0))
   If v Then
      Var2$ = Left$(Var2$, v - 1)
   End If
   If Var2$ = "." Then
      Var2$ = Nul
   End If
   Ambiguate$ = Var2$
End Function

' display prompt help
Sub DisplayPromptHelp (Var$)
   Print
   Select Case Var$
      Case MorePrompt1 ' "More(y/n/c)?"
         Color White
         Print " Y = Yes"
         Print " N = No"
         Print " C = Continuous"
         Color Yellow
      Case MorePrompt2 ' "More(y/n)?"
         Color White
         Print " Y = Yes"
         Print " N = No"
         Color Yellow
      Case MorePrompt3 ' "(y/n/q)?"
         Color White
         Print " Y = Yes"
         Print " N = No"
         Print " Q = Quit"
         Color Yellow
      Case MorePrompt4 ' "-more-"
         Color White
         Print " <space> = continue"
         Print " <enter> = continue"
         Color Yellow
      Case Else
         Color White
         Print " Y = Yes"
         Print " N = No"
         Color Yellow
   End Select
End Sub

' prompts for a keystroke
Sub KeyPrompt
   If BootError = False Then
      Color White, Black
      Locate , , 1
      Print "Press any key to continue:";
      Do
         _Limit 50
         Var$ = InKey$
         If ControlBreak Then
            ControlBreak = False
            Exit Do
         End If
         If Len(Var$) Then
            Exit Do
         End If
      Loop
      Print
   End If
End Sub

' replaces white spaces with nul,
' var = true; skip spaces in quotes
Function XTRIM$ (Var$, Var)
   VarX$ = Var$
   Temp = False
   Do
      Temp = Temp + 1
      If Temp > Len(VarX$) Then
         Exit Do
      End If
      If Var Then
         If Mid$(VarX$, Temp, 1) = Chr$(34) Then
            Do
               Temp = Temp + 1
               If Temp > Len(VarX$) Then
                  Exit Do
               End If
               If Mid$(VarX$, Temp, 1) = Chr$(34) Then
                  Exit Do
               End If
            Loop
         End If
      End If
      For Blanks = 1 To Len(WhiteSpace)
         If Mid$(VarX$, Temp, 1) = Mid$(WhiteSpace, Blanks, 1) Then
            VarX$ = Left$(VarX$, Temp - 1) + Mid$(VarX$, Temp + 1)
            Temp = Temp - 1
            Exit For
         End If
      Next
   Loop
   XTRIM$ = VarX$
End Function

' calculate byte suffix
Sub Suffix (Var#, Var3$)

   Rem B  (Byte) = 00x - 0FFx (hexidecimal zero-based)
   Rem KB (Kilobyte) = 1024 B
   Rem MB (Megabyte) = 1024 KB (1 MB B)
   Rem GB (Gigabyte) = 1024 MB
   Rem TB (Terabyte) = 1024 GB (1 MB MB)
   Rem PB (Petabyte) = 1024 TB
   Rem EB (Exabyte) = 1024 PB (1 MB TB)
   Rem ZB (Zettabyte) = 1024 EB
   Rem YB (Yottabyte) = 1024 ZB (1 MB EB)

   ' 1.#INF and -1.#INF and -1.#IND and 1#QNAN
   If InStr(Str$(Var#), "#") Then
      Var3$ = LTrim$(Str$(Var#))
      Exit Sub
   End If

   ' check double
   VarX# = Var#
   s$ = Str$(VarX#)
   If InStr(s$, "D") Then
      Var3$ = s$
      Exit Sub
   End If

   ' get sign
   If VarX# < 0# Then
      Sign = -1
      VarX# = Abs(VarX#)
   End If

   ' calculate bytes
   TempA = False
   Do
      If VarX# >= ByteDivisor Then
         VarX# = VarX# / ByteDivisor
         TempA = TempA + 1
         If TempA = 8 Then
            Exit Do
         End If
      Else
         Exit Do
      End If
   Loop

   ' calculate byte string
   Var3$ = FormatString$(VarX#)
   If InStr(Var3$, ".") Then
      Var3$ = Left$(Var3$, InStr(Var3$, ".") + 1)
   Else
      Var3$ = Var3$ + ".0"
   End If

   ' calculate byte suffix
   Var$ = Nul
   If TempA > 0 Then
      Var$ = Mid$("KMGTPEZY", TempA, 1)
   End If
   Var3$ = Var3$ + " " + Var$ + "B"

   ' calculate byte sign
   If Sign Then
      Var3$ = "-" + Var3$
   End If
End Sub

Function IsNumeric (x$)
   For V = 1 To Len(x$)
      If Mid$(x$, V, 1) >= "0" And Mid$(x$, V, 1) <= "9" Then
         Eat$ = Nul
      Else
         IsNumeric = 0
         Exit Function
      End If
   Next
   IsNumeric = -1
End Function

' display windows error message
Function DisplayWinError$ (x)
   Dim ErrorBuffer As String * 260
   x = -1
   ' define error message value
   v& = GetLastError
   ' call windows error message routine
   x& = FormatMessageA&(&H1200, "", v&, 0, ErrorBuffer$, 260, "")
   If x& Then
      DisplayWinError$ = Left$(ErrorBuffer$, x& - 2)
   Else
      DisplayWinError$ = "Unknown error 0x" + Hex$(v&) + "."
   End If
End Function
